﻿using System;
using System.Data;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;

/// <summary>
/// Třída pro práci s účty administratorů.
/// </summary>
public class Administrator : Uzivatel
{

    /// <summary>
    /// Administrator.
    /// </summary>
    /// <param name="idAdmin">Id administratora.</param>
    public Administrator(string idAdmin)
        : base(idAdmin)
    {
    }

    /// <summary>
    /// Administrátor.
    /// </summary>
    /// <param name="idPartnera">Id partnera.</param>
    /// <param name="nick">Uživatelské jméno.</param>    
    /// <param name="jmeno">Jméno.</param>
    /// <param name="prijmeni">Přijmení.</param>
    /// <param name="email">Email.</param>
    /// <param name="partnerskyKod">Partnerský kód.</param>
    /// <param name="telefonniCislo">Telefonní číslo.</param>
    /// <param name="firma">Název firmy partnera.</param>
    public Administrator(string idAdmin, string nick, string jmeno, string prijmeni, string email, string telefonniCislo)
        : base(idAdmin, nick, "", jmeno, prijmeni, email, telefonniCislo)
    {
        
    }

    /// <summary>
    /// Načte admina z databáze.
    /// </summary>
    /// <returns><c>True</c> v případě, že načtení proběhlo úspěšně, jinak <c>false</c>.</returns>
    public bool Nacist()
    {
        return base.Nacist();
    }

    /// <summary>
    /// Uloží administratora do databáze.
    /// </summary>
    /// <returns><c>True</c> v případě, že uložení proběhlo úspěšně, jinak <c>false</c>.</returns>
    public bool Ulozit()
    {
        return base.Ulozit();
    }

    /// <summary>
    /// Smaže administratora z databáze.
    /// </summary>
    /// <returns><c>True</c> v případě, že smazání proběhlo úspěšně, jinak <c>false</c>.</returns>
    public bool Smazat()
    {
        return true;
    }

}
