﻿using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Data.SqlClient;

/// <summary>
/// Třída pro práci s databází
/// </summary>
public class Databaze
{
    private static string sqlConnectionString = ConfigurationManager.ConnectionStrings["ConnectionString"].ConnectionString;
    /// <summary>
    /// Konstruktor připojení do databáze (nastaví kódování)
    /// </summary>
    public Databaze()
    {

        this.connection = new SqlConnection(sqlConnectionString);
        this.connection.Open();

        this.command = new SqlCommand();
        this.command.Connection = connection;


    }

    private SqlConnection connection;
    private SqlCommand command;
    private SqlDataReader reader;

    /// <summary>
    /// Vrátí SqlConnection
    /// </summary>
    /// <returns>SqlConnection</returns>
    public static SqlConnection GetConnection()
    {
        return new SqlConnection(sqlConnectionString); ;
    }

    /// <summary>
    /// Nastaví command text
    /// </summary>
    /// <param name="dotaz">dotaz</param>
    public void SetCommandText(string dotaz)
    {
        if (this.reader != null)
        {
            if (!this.reader.IsClosed)
            {
                this.reader.Close();
            }
        }
        this.command.CommandText = dotaz;
    }

    /// <summary>
    /// Nastaví command
    /// </summary>
    /// <param name="dotaz">sqlCommand</param>
    public void SetCommand(SqlCommand cmd)
    {
        if (this.reader != null)
        {
            if (!this.reader.IsClosed)
            {
                this.reader.Close();
            }
        }
        cmd.Connection = this.connection;
        this.command = cmd;
    }

    /// <summary>
    /// Vykoná dotaz v databázi
    /// </summary>
    /// <returns>Data reader</returns>
    public SqlDataReader ExecuteReader()
    {

        return this.reader = this.command.ExecuteReader();
    }



}
