﻿using System;
using System.Data;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;

/// <summary>
/// Třída pro práci se vzkazem diskuzního fóra
/// </summary>
public class DiskusniForumVzkaz
{
    private DateTime datum;
    private Uzivatel autor;
    private string text;
    private int forum;

    /// <summary>
    /// Vzkaz diskusního fóra
    /// </summary>
    /// <param name="forum">Bit diskusnihho fora - 0 pro veřejné, 1 pro fórum pro zaměstnance lyžařské školy</param>
    public DiskusniForumVzkaz(int forum)
    {
        this.forum = forum;
        this.text = "";
    }

    /// <summary>
    /// Vzkaz diskusního fóra
    /// </summary>
    /// <param name="forum">Id diskusního fora - 0 pro veřejné, 1 pro fórum pro zaměstnance lyžařské školy</param>
    /// <param name="autor">Autor vzkazu</param>
    /// <param name="datum">Datum vzkazu</param>
    /// <param name="text">Text vzkazu</param>
    public DiskusniForumVzkaz(int forum, Uzivatel autor, DateTime datum, string text)
    {
        this.forum = forum;
        this.autor = autor;
        this.datum = datum;
        this.text = text;
    }

    /// <summary>
    /// Vrátí nebo nastaví datum vložení vzkazu.
    /// </summary>
    public DateTime Datum
    {
        get { return datum; }
        set { datum = value; }
    }

    /// <summary>
    /// Vrátí nebo nastaví autora vzkazu.
    /// </summary>
    public Uzivatel Autor
    {
        get { return autor; }
        set { autor = value; }
    }

    /// <summary>
    /// Vrátí nebo nastaví text vzkazu.
    /// </summary>
    public string Text
    {
        get { return text; }
        set { text = value; }
    }

    /// <summary>
    /// Vrátí nebo nastaví id diskusního fora - 0 pro veřejné, 1 pro fórum pro zaměstnance lyžařské školy
    /// </summary>
    public int Forum
    {
        get { return forum; }
        set { forum = value; }
    }

    /// <summary>
    /// Uloží vzkaz do fóra.
    /// </summary>
    /// <returns><c>True</c> v případě, že uložení proběhlo v pořádku, jinak <c>false</c>.</returns>
    public bool UlozitVzkaz()
    {
        try
        {
            Databaze databaze = new Databaze();
            databaze.SetCommandText("INSERT INTO forum (datumVlozeni, autorVzkazu, forum, text) VALUES ('" + DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss") + "','" + this.autor.Id + "','" + this.forum + "','" + this.text + "')");
            databaze.ExecuteReader();
            return true;
        }
        catch (Exception)
        {
            return false;
        }
    }

    /// <summary>
    /// Smaže vzkaz z databáze.
    /// </summary>
    /// <returns><c>True</c> v případě, že smazání proběhlo v pořádku, jinak <c>false</c>.</returns>
    public bool SmazatVzkaz()
    {
        try
        {
            Databaze databaze = new Databaze();
            databaze.SetCommandText("DELETE FROM forum WHERE datumVlozeni='" + this.datum.ToString("yyyy-MM-dd HH:mm:ss") + "' AND autorVzkazu='" + this.autor.Id + "' AND forum='" + this.forum + "';");
            databaze.ExecuteReader();
            return true;
        }
        catch (Exception)
        {
            return false;
        }
    }
}
