﻿using System;
using System.Data;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.Data.SqlClient;

/// <summary>
/// Třída pro práci s instruktory.
/// </summary>
public class Instruktor : Uzivatel
{
    private string informace;

    /// <summary>
    /// Instruktor.
    /// </summary>
    /// <param name="idInstruktora">Id instruktora.</param>
    public Instruktor(string idInstruktora)
        : base(idInstruktora)
    {
        this.informace = "";
    }

    /// <summary>
    /// Instruktor.
    /// </summary>
    /// <param name="idInstruktora">Id instruktora.</param>
    /// <param name="userName">Nick instruktora.</param>
    /// <param name="email">Email.</param>
    /// <param name="jmeno">Jméno.</param>
    /// <param name="prijmeni">Příjmení.</param>
    /// <param name="telefonniCislo">Telefonní číslo.</param>
    /// <param name="informace">Informace o instruktorovi, které budou zveřejněné na internetových stránkách.</param>
    public Instruktor(string idInstruktora, string userName, string email, string jmeno, string prijmeni, string telefonniCislo, string informace)
        : base(idInstruktora, userName, "", jmeno, prijmeni, email, telefonniCislo)
    {
        this.informace = informace;
    }


    /// <summary>
    /// Vrátí nebo nastaví informace.
    /// </summary>
    public string Informace
    {
        get { return informace; }
        set { informace = value; }
    }

    /// <summary>
    /// Uloží instruktora do databáze.
    /// </summary>
    /// <returns><c>True</c> v případě, že uložení proběhlo úspěšně, jinak <c>false</c>.</returns>
    public bool Ulozit()
    {
        try
        {
            if (base.Ulozit())
            {
                Databaze databaze = new Databaze();

                bool exist = false;
                databaze.SetCommandText("SELECT 'r' FROM instruktor WHERE idUzivatele='" + this.Id + "'");
                SqlDataReader reader = databaze.ExecuteReader();
                while (reader.Read())
                    exist = true;

                if (exist)
                    databaze.SetCommandText("UPDATE instruktor SET informace='" + this.Informace + "' WHERE idUzivatele='" + this.Id + "';");
                else
                    databaze.SetCommandText("INSERT INTO instruktor (idUzivatele, informace) VALUES ('" + this.Id + "', '" + this.informace + "');");
                databaze.ExecuteReader();
                return true;
            }
            else
                return false;
        }
        catch (Exception)
        {
            return false;
        }
    }

    /// <summary>
    /// Načte zákazníka z databáze.
    /// </summary>
    /// <returns><c>True</c> v případě, že načtení proběhlo úspěšně, jinak <c>False</c>.</returns>
    public bool Nacist()
    {
        if (base.Nacist())
        {
            try
            {
                Databaze databaze = new Databaze();
                databaze.SetCommandText("SELECT informace FROM instruktor WHERE idUzivatele='" + this.Id + "';");
                SqlDataReader reader = databaze.ExecuteReader();
                while (reader.Read())
                {
                    this.informace = reader["informace"].ToString();
                    return true;
                }
            }
            catch (Exception)
            {
                return false;
            }
        }
        return false;
    }

    /// <summary>
    /// Smaže instruktora z databáze.
    /// </summary>
    /// <returns><c>True</c> v případě, že smazání proběhlo úspěšně, jinak <c>False</c>.</returns>
    public bool Smazat()
    {
        try
        {
            Databaze databaze = new Databaze();
            databaze.SetCommandText("DELETE FROM instruktor WHERE idUzivatele='" + this.Id + "';");
            databaze.ExecuteReader();

            return true;
        }
        catch (Exception)
        {
            return false;
        }
    }
}
