﻿using System;
using System.Data;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;

/// <summary>
/// Třída pro práci s položkami ceníku.
/// </summary>
public class PolozkaCeniku
{
    private float cena;
    private int doba;

    /// <summary>
    /// Položka ceníku.
    /// </summary>
    /// <param name="cena">Cena</param>
    /// <param name="doba">Doba (0 pro každý další den)</param>
    public PolozkaCeniku(float cena, int doba)
    {
        this.doba = doba;
        this.cena = cena;
    }

    /// <summary>
    /// Vrátí nebo nastaví cenu.
    /// </summary>
    public float Cena
    {
        get { return cena; }
        set { this.cena = value; }
    }

    /// <summary>
    /// Vrátí nebo nastaví doba
    /// </summary>
    public int Doba
    {
        get { return this.doba; }
        set { this.doba = value; }
    }
}
