﻿using System;
using System.Data;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;

/// <summary>
/// Třída pro práci s položkou rezervace lyžařského vybavení
/// </summary>
public class RezervaceLyzarskehoVybaveniPolozky
{
    private string typ;
    private int vyska;
    private int vaha;
    private float velikostBoty;
    private float cena;

    /// <summary>
    /// Položka rezervace lyžařského vybavení
    /// </summary>
    /// <param name="typ">Typ (název) vybavení</param>
    /// <param name="vyska">Výška</param>
    /// <param name="vaha">Váha</param>
    /// <param name="velikostBoty">Velikost boty</param>
    /// <param name="cena">Cena</param>
    public RezervaceLyzarskehoVybaveniPolozky(string typ, int vyska, int vaha, float velikostBoty, float cena)
    {
        this.typ = typ;
        this.vyska = vyska;
        this.vaha = vaha;
        this.velikostBoty = velikostBoty;
        this.cena = cena;
    }

    /// <summary>
    /// Vrátí nebo nastaví typ (název) vybavení
    /// </summary>
    public string Typ
    {
        get { return typ; }
        set { typ = value; }
    }

    /// <summary>
    /// Vrátí nebo nastaví výška
    /// </summary>
    public int Vyska
    {
        get { return vyska; }
        set { vyska = value; }
    }

    /// <summary>
    /// Vrátí nebo nastaví váha
    /// </summary>
    public int Vaha
    {
        get { return vaha; }
        set { vaha = vaha; }
    }

    /// <summary>
    /// Vrátí nebo nastaví velikost boty
    /// </summary>
    public float VelikostBoty
    {
        get { return velikostBoty; }
        set { velikostBoty = value; }
    }

    /// <summary>
    /// Vrátí nebo nastaví cena
    /// </summary>
    public float Cena
    {
        get { return cena; }
        set { cena = value; }
    }
}
