﻿using System;
using System.Data;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.Data.SqlClient;

/// <summary>
/// Třída pro práci se stavy rezervace
/// </summary>
public class RezervaceStav
{
    private int idStavuRezervace;
    private string nazevStavuRezervace;
    private string informace;

    /// <summary>
    /// Stav rezervace
    /// </summary>
    /// <param name="idStavuRezervace">Id stavu rezervace</param>
    public RezervaceStav(int idStavuRezervace)
    {
        this.idStavuRezervace = idStavuRezervace;
        this.nazevStavuRezervace = "";
        this.informace = "";
    }

    /// <summary>
    /// Stav rezervace
    /// </summary>
    /// <param name="idStavuRezervace">Název stavu rezervace</param>
    public RezervaceStav(string nazevStavuRezervace)
    {
        this.idStavuRezervace = 0;
        this.nazevStavuRezervace = nazevStavuRezervace;
        this.informace = "";
    }

    /// <summary>
    /// Stav rezervace
    /// </summary>
    /// <param name="idStavuRezervace">Id stavu rezervace</param>
    /// <param name="nazevStavuRezervace">Název stavu rezervace</param>
    /// <param name="popisStavuRezervace">Popis stavu rezervace</param>
    public RezervaceStav(int idStavuRezervace, string nazevStavuRezervace, string popisStavuRezervace)
    {
        this.idStavuRezervace = idStavuRezervace;
        this.nazevStavuRezervace = nazevStavuRezervace;
        this.informace = popisStavuRezervace;
    }

    /// <summary>
    /// Vrátí nebo nastaví id stavu rezervace
    /// </summary>
    public int IdStavuRezervace
    {
        get { return idStavuRezervace; }
        set { idStavuRezervace = value; }
    }

    /// <summary>
    /// Vrátí nebo nastaví název stavu rezervace
    /// </summary>
    public string NazevStavuRezervace
    {
        get { return nazevStavuRezervace; }
        set { nazevStavuRezervace = value; }
    }

    /// <summary>
    /// Vrátí nebo nastaví informace o stavu rezervace
    /// </summary>
    public string Informace
    {
        get { return informace; }
        set { informace = value; }
    }


    /// <summary>
    /// Načte stav rezervace.
    /// </summary>
    /// <returns><c>True</c>, pokud načtení proběhlo v pořádku, jinak <c>false</c>.</returns>
    public bool NacistStavRezervace()
    {
        try
        {
            Databaze databaze = new Databaze();
            databaze.SetCommandText("SELECT stavRezervace, info FROM rezervaceStav WHERE idStavuRezervace='" + this.idStavuRezervace + "';");
            SqlDataReader reader = databaze.ExecuteReader();
            while (reader.Read())
            {
                this.nazevStavuRezervace = reader["stavRezervace"].ToString();
                this.informace = reader["info"].ToString();
            }
            return true;
        }
        catch (Exception)
        {
            return false;
        }
    }

    /// <summary>
    /// Smaže stav rezervace z databáze.
    /// </summary>
    /// <returns><c>True</c>, pokud smazání proběhlo v pořádku, jinak <c>false</c>.</returns>
    public bool SmazatStavRezervace()
    {
        try
        {
            Databaze databaze = new Databaze();

            // Smazání stavu rezeravce
            databaze.SetCommandText("DELETE FROM rezervaceStav WHERE idStavuRezervace='" + this.idStavuRezervace + "';");
            databaze.ExecuteReader();

            return true;
        }
        catch (Exception)
        {
            return false;
        }
    }


    /// <summary>
    /// Uloží stav rezervace do databáze.
    /// </summary>
    /// <returns><c>True</c>, pokud uložení proběhlo v pořádku, jinak <c>false</c>.</returns>
    public bool UlozitStavRezervace()
    {
        try
        {
            Databaze databaze = new Databaze();
            SqlCommand cmd;

            if (this.idStavuRezervace != 0)
                databaze.SetCommandText("UPDATE rezervaceStav SET stavRezervace='" + this.nazevStavuRezervace + "', info='" + this.informace + "' WHERE idStavurezervace='" + this.idStavuRezervace + "';");
            else
            {
                databaze.SetCommandText("SELECT MAX(idStavuRezervace) AS max FROM rezervaceStav;");
                SqlDataReader reader = databaze.ExecuteReader();
                while (reader.Read())
                    if (int.TryParse(reader["max"].ToString(), out this.idStavuRezervace))
                        this.idStavuRezervace = int.Parse(reader["max"].ToString());
                this.idStavuRezervace += 1;

                databaze.SetCommandText("INSERT INTO rezervaceStav (idStavuRezervace, stavRezervace, info) VALUES ('" + this.idStavuRezervace + "', '" + this.nazevStavuRezervace + "', '" + this.informace + "');");
            }
            databaze.ExecuteReader();

            return true;

        }
        catch (Exception)
        {
            return false;
        }
    }

}
