﻿using System;
using System.Data;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.Collections;
using System.Data.SqlClient;

/// <summary>
/// Summary description for SpravceDiskusnihoFora
/// </summary>
public static class SpravceDiskusnihoFora
{
   

    /// <summary>
    /// Načte vzkazy diskusního fóra.
    /// </summary>
    /// <param name="forum">Index diskusnihho fora - 0 pro veřejné, 1 pro fórum pro zaměstnance lyžařské školy.</param>
    /// <returns>Seznam vzkazů fóra.</returns>
    public static DataSet NactiVzkazyDiskusnihoFora(int forum)
    {
        SqlDataAdapter adapter = new SqlDataAdapter("SELECT autorVzkazu, UserName, datumVlozeni, text FROM forumView WHERE (forum=" + forum + ") ORDER BY datumVlozeni DESC;", Databaze.GetConnection());
        DataSet ds = new DataSet();
        adapter.Fill(ds);
        return ds;
    }

    /// <summary>
    /// Vloží nový vzkaz do fóra.
    /// </summary>
    /// <param name="forum">Index diskusnihho fora - 0 pro veřejné, 1 pro fórum pro zaměstnance lyžařské školy.</param>
    /// <param name="idUzivatele">Id uživatele, který vzkaz vkládá.</param>
    /// <param name="text">Text vzkazu.</param>
    /// <returns><c>True</c> v případě, že uložení proběhlo v pořádku, jinak <c>false</c>.</returns>
    public static bool VlozitNovyVzkaz(int forum, string idUzivatele, string text)
    {
        DiskusniForumVzkaz vzkaz = new DiskusniForumVzkaz(forum, new Zakaznik(idUzivatele), DateTime.Now, text);
        return vzkaz.UlozitVzkaz();
    }

    /// <summary>
    /// Smaže vzkaz z fóra.
    /// </summary>
    /// <param name="forum">Index diskusnihho fora - 0 pro veřejné, 1 pro fórum pro zaměstnance lyžařské školy.</param>
    /// <param name="datumVlozeni">Datum vložení vzkazu.</param>
    /// <param name="UserName">Id autora vzkazu.</param>
    /// <returns></returns>
    public static bool SmazatVzkaz(int forum, DateTime datumVlozeni, string UserName)
    {
        string idUzivatele = SpravceUzivatelu.ZjistitIdUzivatele(UserName);
        DiskusniForumVzkaz vzkaz = new DiskusniForumVzkaz(forum, new Zakaznik(idUzivatele), datumVlozeni, "");
        return vzkaz.SmazatVzkaz();
    }

    /// <summary>
    /// Smaže vzkazy uživatele.
    /// </summary>
    /// <param name="idUser">Id uživatele, jehož vzkazy mají být smazány.</param>
    /// <returns></returns>
    public static bool SmazatVzkazyUzivatele(string idUser)
    {
        try
        {
            Databaze databaze = new Databaze();
            databaze.SetCommandText("DELETE FROM forum WHERE autorVzkazu='" + idUser + "';");
            databaze.ExecuteReader();

            return true;
        }
        catch (Exception)
        {
            return false;
        }
    }

}
