﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;

public partial class MeProvize : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.User.Identity.IsAuthenticated || !Page.User.IsInRole("partner"))
            Response.Redirect("Default.aspx");

        ArrayList seznamProvizi = SpravceRezervaci.NacistSeznamProviziPartnera(Profile.userId);


        int nestanovenaCena = 0; float vyplacenoCelkem = 0; float zbyvaVyplatit = 0;
        foreach (Provize provize in seznamProvizi)
        {
            TableRow tr = new TableRow();

            TableCell td = new TableCell();
            td.Text = provize.Rezervace.ReferencniCislo.ToString();
            tr.Cells.Add(td);

            td = new TableCell();
            td.Text = provize.Rezervace.ZacatekRezervace.ToShortDateString();
            tr.Cells.Add(td);

            td = new TableCell();
            td.Text = provize.Rezervace.KonecRezervace.ToShortDateString();
            tr.Cells.Add(td);

            td = new TableCell();
            td.Text = provize.Rezervace.Pobocka.NazevPobocky;
            tr.Cells.Add(td);

            td = new TableCell();
            td.Text = provize.Rezervace.CenaKonecna.ToString("f2") + " Kč";
            tr.Cells.Add(td);

            td = new TableCell();
            td.Text = provize.Rezervace.StavRezervace.NazevStavuRezervace;
            tr.Cells.Add(td);

            td = new TableCell();
            if (provize.VyseProvize == 0)
            {
                td.Text = "nestanovena";
                nestanovenaCena++;
            }
            else
                td.Text = provize.VyseProvize.ToString("f2") + " Kč";
            tr.Cells.Add(td);

            td = new TableCell();
            if (provize.DatumVyplaceni.ToShortDateString() == "1.1.0001")
                td.Text = "nevyplaceno";
            else
                td.Text = provize.DatumVyplaceni.ToShortDateString();
            tr.Cells.Add(td);

            if (provize.VyseProvize != 0 && provize.DatumVyplaceni.ToShortDateString() == "1.1.0001")
            {
                tr.BackColor = System.Drawing.Color.Red;
                zbyvaVyplatit += provize.VyseProvize;
            }
            else if (provize.DatumVyplaceni.ToShortDateString() != "1.1.0001")
            {
                tr.BackColor = System.Drawing.Color.Green;
                vyplacenoCelkem += provize.VyseProvize;
            }
            meProvizeTable.Rows.Add(tr);
        }

        celkemVyplacenoLiteral.Text = vyplacenoCelkem.ToString("f2");
        zbyvaVyplatitLiteral.Text = zbyvaVyplatit.ToString("f2");
        nestanovenoLiteral.Text = nestanovenaCena.ToString();

    }
}
