﻿<%@ Page Language="C#" MasterPageFile="~/RezervacniSystemMasterPage.master" AutoEventWireup="true"
    CodeFile="MeRezervace.aspx.cs" Inherits="MeRezervace" Title="Mé rezervace" %>

<asp:Content ID="Content1" ContentPlaceHolderID="head" runat="Server">
</asp:Content>
<asp:Content ID="Content2" ContentPlaceHolderID="obsahStranky" runat="Server">
    <h1>
        Rezervace
        <asp:Literal ID="cisloRezervaceLiteral" runat="server"></asp:Literal>
    </h1>
    <p class="zvyreznenaInformace">
        <asp:Literal ID="informaceLiteral" runat="server"></asp:Literal>
    </p>
    <asp:Panel ID="prehledRezervaciPanel" runat="server" Visible="false">
        <asp:GridView ID="meRezervaceGridView" runat="server" DataSourceID="meRezervaceObjectDataSource">
            <Columns>
                <asp:BoundField DataField="idRezervace" HeaderText="Ref. č." SortExpression="idRezervace" />
                <asp:BoundField DataField="od" DataFormatString="{0:dd.MM.yyyy}" HeaderText="Začátek"
                    SortExpression="od" />
                <asp:BoundField DataField="do" DataFormatString="{0:dd.MM.yyyy}" HeaderText="Konec"
                    SortExpression="do" />
                <asp:BoundField DataField="nazevPobocky" HeaderText="Pobočka" SortExpression="nazevPobocky" />
                <asp:BoundField DataField="cenaPredSlevou" DataFormatString="{0:f2} Kč" HeaderText="Cena před slevou"
                    SortExpression="cenaPredSlevou">
                    <ItemStyle HorizontalAlign="Right" />
                </asp:BoundField>
                <asp:BoundField DataField="slevaCelkem" DataFormatString="{0} %" HeaderText="Sleva"
                    SortExpression="slevaCelkem">
                    <ItemStyle HorizontalAlign="Right" />
                </asp:BoundField>
                <asp:BoundField DataField="cenaKonecna" DataFormatString="{0:f2} Kč" HeaderText="Konečná cena"
                    SortExpression="cenaKonecna">
                    <ItemStyle HorizontalAlign="Right" />
                </asp:BoundField>
                <asp:BoundField DataField="stavRezervace" HeaderText="Stav" SortExpression="stavRezervace" />
                <asp:HyperLinkField DataNavigateUrlFields="idRezervace" DataNavigateUrlFormatString="~/MeRezervace.aspx?detail={0}"
                    HeaderText="Detail" Text="detail" />
            </Columns>
        </asp:GridView>
        <asp:ObjectDataSource ID="meRezervaceObjectDataSource" runat="server" SelectMethod="NactiSeznamRezervaciZakaznika"
            TypeName="SpravceRezervaci">
            <SelectParameters>
                <asp:ProfileParameter Name="idUzivatele" PropertyName="userId" Type="String" />
            </SelectParameters>
        </asp:ObjectDataSource>
    </asp:Panel>
    <asp:Panel ID="rezervacePanel" runat="server" Visible="false">
        <table style="width: 100%">
            <tr style="border-bottom: 3px solid gray;">
                <th>
                    Stav rezervace:
                </th>
                <td>
                    <asp:Literal ID="stavLiteral" runat="server"></asp:Literal>
                </td>
                <td class="rezervaceCeny">
                    online sleva
                    <asp:Literal ID="slevaOnlineLiteral" runat="server">0</asp:Literal>
                    %
                </td>
            </tr>
            <tr>
                <th>
                    Termín rezervace:
                </th>
                <td>
                    <asp:Literal ID="terminRezervaceDoLiteral" runat="server"></asp:Literal>
                </td>
                <td class="rezervaceCeny">
                    <asp:Literal ID="slevaTerminLiteral" runat="server" Text="0"></asp:Literal>
                    %
                </td>
            </tr>
            <tr>
                <th>
                    Pobočka:
                </th>
                <td>
                    <asp:Literal ID="pobockaLiteral" runat="server"></asp:Literal>
                </td>
            </tr>
            <tr>
                <th>
                    Partnerský kód:
                </th>
                <td>
                    <asp:Literal ID="partnerskyKodLiteral" runat="server"></asp:Literal>
                </td>
                <td class="rezervaceCeny">
                    <asp:Literal ID="slevaPartnerskyKodLiteral" runat="server" Text="0"></asp:Literal>
                    %
                </td>
            </tr>
            <tr style="border-bottom: 3px solid gray;">
                <th>
                    Jiné sdělení:
                </th>
                <td colspan="2">
                    <asp:Literal ID="poznamkaLiteral" runat="server"></asp:Literal>
                </td>
            </tr>
            <asp:Panel ID="lyzarskyKurzPanel" runat="server" Visible="false">
                <tr>
                    <th>
                        Kurz:
                    </th>
                    <td>
                        <asp:Literal ID="kurzLiteral" runat="server"></asp:Literal>
                    </td>
                    <td>
                    </td>
                </tr>
                <tr>
                    <th>
                        Počet osob:
                    </th>
                    <td>
                        <asp:Literal ID="pocetOsobLiteral" runat="server"></asp:Literal>
                    </td>
                    <td class="rezervaceCeny">
                        <asp:Literal ID="slevaPocetOsobLiteral" runat="server" Text="0"></asp:Literal>
                        %
                    </td>
                </tr>
                <tr>
                    <th>
                        Preferovaný instruktor:
                    </th>
                    <td>
                        <asp:Literal ID="preferovanyInstruktorLiteral" runat="server"></asp:Literal>
                    </td>
                </tr>
                <tr>
                    <th>
                        Skutečný instruktor:
                    </th>
                    <td>
                        <asp:Literal ID="skutecnyInstruktorLiteral" runat="server"></asp:Literal>
                    </td>
                </tr>
                <tr>
                    <th>
                        Vaše hodnocení:
                    </th>
                    <td colspan="2">
                        <asp:Literal ID="hodnoceniLiteral" runat="server"></asp:Literal>
                        <asp:Panel ID="hodnoceniPanel" runat="server" Visible="false">
                            <asp:TextBox ID="hodnoceniTextBox" runat="server" Width="350"></asp:TextBox><asp:Button
                                ID="hodnoceniButton" runat="server" Text="Ohodnotit" OnClick="hodnoceniButton_Click" />
                        </asp:Panel>
                    </td>
                </tr>
            </asp:Panel>
            <asp:Panel ID="lyzarskeVybaveniPanel" runat="server" Visible="false">
                <tr style="border-top: 3px solid gray;">
                    <td colspan="3">
                        <asp:Table ID="lyzarskeVybaveniTable" runat="server" CssClass="meobjednavky">
                            <asp:TableHeaderRow>
                                <asp:TableHeaderCell>Set</asp:TableHeaderCell>
                                <asp:TableHeaderCell>Výška, váha, velikost boty</asp:TableHeaderCell>
                                <asp:TableHeaderCell><span style="float: right;">Cena</span></asp:TableHeaderCell>
                            </asp:TableHeaderRow>
                        </asp:Table>
                    </td>
                </tr>
            </asp:Panel>
            <tr style="border-top: 3px solid gray;">
                <th colspan="2">
                    Cena před slevou
                </th>
                <th style="text-align: right;">
                    <asp:Literal ID="cenaPredSlevouLiteral" runat="server" Text="0"></asp:Literal>
                    Kč
                </th>
            </tr>
            <tr>
                <th colspan="2">
                    Sleva celkem
                </th>
                <th style="text-align: right;">
                    <asp:Literal ID="slevaCelkemLiteral" runat="server" Text="4"></asp:Literal>
                    %
                </th>
            </tr>
            <tr class="rezervaceSumCena">
                <th colspan="2">
                    Konečná cena
                </th>
                <th style="text-align: right;">
                    <asp:Literal ID="cenaKonecnaLiteral" runat="server" Text="0"></asp:Literal>
                    Kč
                </th>
            </tr>
        </table>
        <p>
            Zpět na <a href="MeRezervace.aspx">seznam rezervací</a></p>
    </asp:Panel>
    <p class="poznamka">
        Uvedené ceny jsou konečné (včetně DPH).
    </p>
</asp:Content>
