﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;

public partial class MujUcet : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {

        if (!Page.User.Identity.IsAuthenticated)
            Response.Redirect("Default.aspx");

        if (Page.User.IsInRole("zakaznik"))
        {
            Zakaznik zakaznik = SpravceUzivatelu.NacistZakaznika(Profile.userId);
            zakaznikPanel.Visible = true;
            if (!Page.IsPostBack)
            {
                userNameLiteral.Text = zakaznik.Nick;
                Email.Text = zakaznik.Email;
                jmenoTextBox.Text = zakaznik.Jmeno;
                prijmeniTextBox.Text = zakaznik.Prijmeni;
                telefonTextBox.Text = zakaznik.TelefonniCislo;
                uliceTextBox.Text = zakaznik.FakturacniAdresa.Ulice;
                mestoTextBox.Text = zakaznik.FakturacniAdresa.Mesto;
                pscTextBox.Text = zakaznik.FakturacniAdresa.Psc;
            }
        }
        else if (Page.User.IsInRole("instruktor"))
        {
            Instruktor instruktor = SpravceUzivatelu.NacistInstruktora(Profile.userId);
            instruktorPanel.Visible = true;
            if (!Page.IsPostBack)
            {
                VypsatInformaceOUzivateli(instruktor);
                informaceTextBox.Text = instruktor.Informace;
            }
        }
        else if (Page.User.IsInRole("admin"))
        {           
            Administrator admin = SpravceUzivatelu.NacistAdministratora(Profile.userId);
            adminPanel.Visible = true;
            if (!Page.IsPostBack)
            {
                VypsatInformaceOUzivateli(admin);
            }
        }
        else if (Page.User.IsInRole("partner"))
        {
            Partner partner = SpravceUzivatelu.NactiPartnera(Profile.userId);
            partnerPanel.Visible = true;
            if (!Page.IsPostBack)
            {
                VypsatInformaceOUzivateli(partner);
                partnerskyKodLabel.Text = partner.PartnerskyKod;
                firmaTextBox.Text = partner.Firma;
            }
        }


    }

    private void VypsatInformaceOUzivateli(Uzivatel uzivatel)
    {
        userNameLiteral.Text = uzivatel.Nick;
        Email.Text = uzivatel.Email;
        jmenoTextBox.Text = uzivatel.Jmeno;
        prijmeniTextBox.Text = uzivatel.Prijmeni;
        telefonTextBox.Text = uzivatel.TelefonniCislo;
    }


    protected void ulozZakaznikButton_Click(object sender, EventArgs e)
    {
        Zakaznik zakaznik = new Zakaznik(Profile.userId, Profile.UserName, "", jmenoTextBox.Text, prijmeniTextBox.Text, Email.Text, new Adresa(uliceTextBox.Text, mestoTextBox.Text, pscTextBox.Text), telefonTextBox.Text);
        if (SpravceUzivatelu.UlozitInformaceOZakaznikovi(zakaznik))
            AktualizovatProfil(zakaznik);
        else
            ErrorMessage.Text = "Chyba při ukládání.";
    }


    protected void ulozInstruktorButton_Click(object sender, EventArgs e)
    {
        Instruktor instruktor = new Instruktor(Profile.userId, Profile.UserName, Email.Text, jmenoTextBox.Text, prijmeniTextBox.Text, telefonTextBox.Text, informaceTextBox.Text);
        if (SpravceUzivatelu.UlozitInformaceOInstruktorovi(instruktor))
            AktualizovatProfil(instruktor);
        else
            ErrorMessage.Text = "Chyba při ukládání.";
    }
    protected void ulozPartnerButton_Click(object sender, EventArgs e)
    {
        Partner partner = new Partner(Profile.userId, Profile.UserName, jmenoTextBox.Text, prijmeniTextBox.Text, Email.Text, partnerskyKodLabel.Text, telefonTextBox.Text, firmaTextBox.Text);
        if (SpravceUzivatelu.UlozitInformaceOPartnerovi(partner))
            AktualizovatProfil(partner);
        else
            ErrorMessage.Text = "Chyba při ukládání.";
    }
    protected void ulozAdminButton_Click(object sender, EventArgs e)
    {
        Administrator admin = new Administrator(Profile.userId, Profile.UserName, jmenoTextBox.Text, prijmeniTextBox.Text, Email.Text, telefonTextBox.Text);
        if (SpravceUzivatelu.UlozitInformaceOAdministratorovi(admin))
            AktualizovatProfil(admin);
        else
            ErrorMessage.Text = "Chyba při ukládání.";
    }

    private void AktualizovatProfil(Uzivatel uzivatel)
    {
        Profile.jmeno = uzivatel.Jmeno;
        Profile.prijmeni = uzivatel.Prijmeni;
        Profile.email = uzivatel.Email;
    }
}
