﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;

public partial class RezervaceLyzarskeVyuky : System.Web.UI.Page
{

    Slevy slevy;

    protected void Page_Load(object sender, EventArgs e)
    {

        //Pokud není uživatel přihlášen nebo není zákazníkem nebo partnerem, je přesměrován
        if (!Page.User.Identity.IsAuthenticated || (!Page.User.IsInRole("zakaznik") && !Page.User.IsInRole("partner")))
            Response.Redirect("NovaRezervace.aspx");

        if (Page.User.IsInRole("partner") && !Page.IsPostBack)
        {
            Partner partner = SpravceUzivatelu.NactiPartnera(Profile.userId);
            partnerskyKodTextBox.Text = partner.PartnerskyKod;
        }

        slevy = SpravceCeniku.NacistSlevy();
        slevaOnlineLiteral.Text = slevy.OnLineRezervace.ToString();

        if (rezervaceOdTextBox.Text == "")
            rezervaceOdTextBox.Text = DateTime.Today.AddDays(1).ToLongDateString();
        if (rezervaceDoTextBox.Text == "")
            rezervaceDoTextBox.Text = DateTime.Today.AddDays(2).ToLongDateString();
    }

    /// <summary>
    /// Vypočítá cenu za rezervaci
    /// </summary>
    protected void VypocitejCenuRezervaceSpecifikace(object sender, EventArgs e)
    {
        try
        {
            Validate();


            //Aktualizace počtu dní
            int pocetDniRezervace = 0;
            pocetDniRezervace = (int)(DateTime.Parse(rezervaceDoTextBox.Text) - DateTime.Parse(rezervaceOdTextBox.Text)).TotalDays;
            pocetDniLiteral.Text = pocetDniRezervace.ToString() + FunkceRezervacnihoSystemu.GetStringPocetDni(pocetDniRezervace);

            //Vypíše počet osob
            float slevaZaPocetOsob = float.Parse(slevaPocetOsobLiteral.Text);
            if (((Control)sender).ID == "pocetOsobTextBox")
            {
                if (int.Parse(pocetOsobTextBox.Text) <= 0)
                    throw new IndexOutOfRangeException("Špatný zadaný počet osob.");
                pocetOsobLiteral.Text = pocetOsobTextBox.Text + FunkceRezervacnihoSystemu.GetStringPocetOsob(int.Parse(pocetOsobTextBox.Text));

                //Vypíše slevu za počet osob
                slevaZaPocetOsob = slevy.VypocitatSlevuZaPocetOsob(int.Parse(pocetOsobTextBox.Text));
                slevaPocetOsobLiteral.Text = slevaZaPocetOsob.ToString();
            }

            //Vypíše cenu kurzu za pocet dni a pocet osob
            float cenaKurzuZaPocetDniAPocetOsob = SpravceCeniku.VypocitatCenuKurzu(int.Parse(typKurzuDropDownList.SelectedItem.Value), pocetDniRezervace) * int.Parse(pocetOsobTextBox.Text);
            cenaPredSlevouLiteral.Text = cenaKurzuZaPocetDniAPocetOsob.ToString("f2");

            //Vypíše slevu za včasnou rezervaci
            float slevaZaVcasnouRezervaci = slevy.VypocitatSlevuZaVcasnouRezervaci((int)(DateTime.Parse(rezervaceOdTextBox.Text) - DateTime.Today).TotalDays);
            slevaTerminLiteral.Text = slevaZaVcasnouRezervaci.ToString();

            //Vypíše slevu za použití partnerského kódu
            float slevaZaPartnerskyKod;
            if (float.TryParse(slevaPartnerskyKodLiteral.Text, out slevaZaPartnerskyKod))
                slevaZaPartnerskyKod = float.Parse(slevaPartnerskyKodLiteral.Text);
            else
                slevaZaPartnerskyKod = 0;

            if (partnerskyKodTextBox.Text != "")
            {
                slevaZaPartnerskyKod = slevy.VypocitatSlevuZaPartnerskyKod(partnerskyKodTextBox.Text);
                if (slevaZaPartnerskyKod == 0)
                    slevaPartnerskyKodLiteral.Text = "XXX - 0";
                else
                    slevaPartnerskyKodLiteral.Text = slevaZaPartnerskyKod.ToString();
            }

            //Vypíše celkovou slevu
            float celkovaSleva = slevy.VypocitatKonecnouSlevu(slevaZaPocetOsob, slevaZaVcasnouRezervaci, slevaZaPartnerskyKod);
            slevaCelkemLiteral.Text = celkovaSleva.ToString();


            //Vypíše konečnou cenu rezervace
            float cenaKonecna = cenaKurzuZaPocetDniAPocetOsob * (1 - celkovaSleva / 100);
            cenaKonecnaLiteral.Text = cenaKonecna.ToString("f2");
            pokracovatButton.Enabled = true;
        }
        catch (Exception)
        {

        }
    }


    protected void rezervaceOdButton_Click(object sender, EventArgs e)
    {
        if (rezervaceOdCalendar.Visible == true)
        {
            rezervaceOdCalendar.Visible = false;
            rezervaceOdButton.Text = "+";
        }
        else
        {
            rezervaceOdCalendar.Visible = true;
            rezervaceOdButton.Text = "-";
        }
    }


    protected void rezervaceDoButton_Click(object sender, EventArgs e)
    {
        if (rezervaceDoCalendar.Visible == true)
        {
            rezervaceDoCalendar.Visible = false;
            rezervaceDoButton.Text = "+";
        }
        else
        {
            rezervaceDoCalendar.Visible = true;
            rezervaceDoButton.Text = "-";
            rezervaceDoCalendar.SelectedDate = DateTime.Parse(rezervaceDoTextBox.Text);
        }
    }

    protected void rezervaceDoCalendar_SelectionChanged(object sender, EventArgs e)
    {
        if (rezervaceDoCalendar.SelectedDate > rezervaceOdCalendar.SelectedDate)
        {
            rezervaceDoTextBox.Text = rezervaceDoCalendar.SelectedDate.ToLongDateString();
            VypocitejCenuRezervaceSpecifikace(sender, e);
        }
        rezervaceDoCalendar.Visible = false;
        rezervaceDoButton.Text = "+";
    }


    protected void rezervaceOdCalendar_SelectionChanged(object sender, EventArgs e)
    {
        if (rezervaceOdCalendar.SelectedDate < DateTime.Today.AddDays(1))
            rezervaceOdCalendar.SelectedDate = DateTime.Today.AddDays(1);

        rezervaceOdTextBox.Text = rezervaceOdCalendar.SelectedDate.ToLongDateString();
        rezervaceOdCalendar.Visible = false;
        rezervaceOdButton.Text = "+";
        if (rezervaceDoCalendar.SelectedDate < rezervaceOdCalendar.SelectedDate)
        {
            rezervaceDoCalendar.SelectedDate = rezervaceOdCalendar.SelectedDate.AddDays(1);
            rezervaceDoCalendar.VisibleDate = rezervaceOdCalendar.SelectedDate.AddDays(1);
            rezervaceDoTextBox.Text = rezervaceDoCalendar.SelectedDate.ToLongDateString();
        }
        VypocitejCenuRezervaceSpecifikace(sender, e);


    }

    protected void pokracovatButton_Click(object sender, EventArgs e)
    {
        terminPanel.Enabled = false;
        pokracovatButton.Visible = false;
        potvrditPanel.Visible = true;
    }
    protected void upravitButton_Click(object sender, EventArgs e)
    {
        terminPanel.Enabled = true;
        pokracovatButton.Visible = true;
        potvrditPanel.Visible = false;
    }
    protected void potvrditButton_Click(object sender, EventArgs e)
    {
        string partnerskyKod;
        float slevaPartnerskyKod;



        Slevy aktualniSlevy = new Slevy();
        aktualniSlevy.OnLineRezervace = float.Parse(slevaOnlineLiteral.Text);
        aktualniSlevy.VcasnaRezervace = float.Parse(slevaTerminLiteral.Text);
        aktualniSlevy.SlevaPocetOsob = float.Parse(slevaPocetOsobLiteral.Text);
        aktualniSlevy.MaximalniSleva = float.Parse(slevaCelkemLiteral.Text);
        if (float.TryParse(slevaPartnerskyKodLiteral.Text, out slevaPartnerskyKod))
        { partnerskyKod = partnerskyKodTextBox.Text; aktualniSlevy.PouzitiPartnerskehoKodu = float.Parse(slevaPartnerskyKodLiteral.Text); }
        else
        { partnerskyKod = ""; aktualniSlevy.PouzitiPartnerskehoKodu = 0; }


        if (SpravceRezervaci.VytvoritRezervaciLyzarskeVyuky(new Zakaznik(Profile.userId), new Pobocka(int.Parse(pobockaDropDownList.SelectedItem.Value)), partnerskyKod,
            float.Parse(cenaPredSlevouLiteral.Text), aktualniSlevy, float.Parse(cenaKonecnaLiteral.Text),
            DateTime.Parse(rezervaceOdTextBox.Text), DateTime.Parse(rezervaceDoTextBox.Text), int.Parse(pocetOsobTextBox.Text), typKurzuDropDownList.SelectedItem.Text, preferovanyInstruktorDropDownList.SelectedItem.Value, poznamkaTextBox.Text))
            Response.Redirect("RezervacePotvrzeni.aspx");
        else
            errorLiteral.Visible = true;

    }

    protected void preferovanyInstruktorDropDownList_DataBound(object sender, EventArgs e)
    {
        ListItem newListItem = new ListItem("-", "");
        newListItem.Selected = true;
        preferovanyInstruktorDropDownList.Items.Add(newListItem);
        VypocitejCenuRezervaceSpecifikace(sender, e);
    }

}
