﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;

public partial class RezervaceSkiBalicku : System.Web.UI.Page
{
    private Slevy slevy;
    protected void Page_Init(object sender, EventArgs e)
    {
        for (int i = 0; i < int.Parse(pocetOsobTextBox.Text); i++)
        {
            VytvorDynamickyRadekSetu(i);
        }
    }

    protected void VytvorDynamickyRadekSetu(int i)
    {
        dynPlozkyPanel.Controls.Add(new LiteralControl("<tr><td>" + (i + 1).ToString() + ". "));

        //Výběr setu
        DropDownList setDropDownList = new DropDownList();
        setDropDownList.ID = "set" + i.ToString() + "DropDownList";
        setDropDownList.DataSourceID = "setSqlDataSource";
        setDropDownList.DataTextField = "nazev";
        setDropDownList.DataValueField = "idVybaveni";
        dynPlozkyPanel.Controls.Add(setDropDownList);

        dynPlozkyPanel.Controls.Add(new LiteralControl("</td><td>"));

        //Text box výška
        TextBox vyskaTextBox = new TextBox();
        vyskaTextBox.ID = "vyska" + i.ToString() + "TextBox";
        vyskaTextBox.Width = Unit.Pixel(30);
        dynPlozkyPanel.Controls.Add(vyskaTextBox);
        dynPlozkyPanel.Controls.Add(new LiteralControl("cm, "));

        //Text box váha
        TextBox vahaTextBox = new TextBox();
        vahaTextBox.ID = "vaha" + i.ToString() + "TextBox";
        vahaTextBox.Width = Unit.Pixel(30);
        dynPlozkyPanel.Controls.Add(vahaTextBox);
        dynPlozkyPanel.Controls.Add(new LiteralControl("kg, velikost boty"));
        //Text box velikost boty
        TextBox velikostBotyTextBox = new TextBox();
        velikostBotyTextBox.ID = "velikostBoty" + i.ToString() + "TextBox";
        velikostBotyTextBox.Width = Unit.Pixel(30);
        dynPlozkyPanel.Controls.Add(velikostBotyTextBox);

        //Validator výška
        RequiredFieldValidator vyskaRequireFild = new RequiredFieldValidator();
        vyskaRequireFild.ControlToValidate = "vyska" + i.ToString() + "TextBox";
        vyskaRequireFild.Display = ValidatorDisplay.Dynamic;
        vyskaRequireFild.ErrorMessage = "<br />Musíte zadat výšku.";
        vyskaRequireFild.ValidationGroup = "sety";
        dynPlozkyPanel.Controls.Add(vyskaRequireFild);

        //Validator váha
        RequiredFieldValidator vahaRequireFild = new RequiredFieldValidator();
        vahaRequireFild.ControlToValidate = "vaha" + i.ToString() + "TextBox";
        vahaRequireFild.Display = ValidatorDisplay.Dynamic;
        vahaRequireFild.ErrorMessage = "<br />Musíte zadat váhu.";
        vahaRequireFild.ValidationGroup = "sety";
        dynPlozkyPanel.Controls.Add(vahaRequireFild);

        //Validator velikost boty
        RequiredFieldValidator velikostBotyRequireFild = new RequiredFieldValidator();
        velikostBotyRequireFild.ControlToValidate = "velikostBoty" + i.ToString() + "TextBox";
        velikostBotyRequireFild.Display = ValidatorDisplay.Dynamic;
        velikostBotyRequireFild.ErrorMessage = "<br />Musíte zadat váhu.";
        velikostBotyRequireFild.ValidationGroup = "sety";
        dynPlozkyPanel.Controls.Add(velikostBotyRequireFild);

        dynPlozkyPanel.Controls.Add(new LiteralControl("</td></tr>"));
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        //Pokud není uživatel přihlášen nebo není zákazníkem nebo partnerem, je přesměrován
        if (!Page.User.Identity.IsAuthenticated || (!Page.User.IsInRole("zakaznik") && !Page.User.IsInRole("partner")))
            Response.Redirect("NovaRezervace.aspx");

        if (Page.User.IsInRole("partner") && !Page.IsPostBack)
        {
            Partner partner = SpravceUzivatelu.NactiPartnera(Profile.userId);
            partnerskyKodTextBox.Text = partner.PartnerskyKod;
        }

        slevy = SpravceCeniku.NacistSlevy();
        slevaOnlineLiteral.Text = slevy.OnLineRezervace.ToString();


        if (rezervaceOdTextBox.Text == "")
        {
            rezervaceOdCalendar.SelectedDate = DateTime.Today.AddDays(1);
            rezervaceOdTextBox.Text = rezervaceOdCalendar.SelectedDate.ToLongDateString();
        }

        for (int i = 0; i < int.Parse(pocetOsobTextBox.Text); i++)
        {
            string idControl = "vyska" + i.ToString() + "TextBox";
            if (setyPanel.FindControl(idControl) == null)
                VytvorDynamickyRadekSetu(i);
        }
    }



    /// <summary>
    /// Strisknutí tlačítka rezervace od
    /// </summary>
    protected void rezervaceOdButton_Click(object sender, EventArgs e)
    {
        if (rezervaceOdCalendar.Visible == true)
        {
            rezervaceOdCalendar.Visible = false;
            rezervaceOdButton.Text = "+";
        }
        else
        {
            rezervaceOdCalendar.Visible = true;
            rezervaceOdButton.Text = "-";
        }
    }



    /// <summary>
    /// Změna výběru data začátku kalednáře
    /// </summary>
    protected void rezervaceOdCalendar_SelectionChanged(object sender, EventArgs e)
    {
        if (rezervaceOdCalendar.SelectedDate < DateTime.Today.AddDays(1))
            rezervaceOdCalendar.SelectedDate = DateTime.Today.AddDays(1);

        rezervaceOdTextBox.Text = rezervaceOdCalendar.SelectedDate.ToLongDateString();
        rezervaceOdCalendar.Visible = false;
        rezervaceOdButton.Text = "+";
        VypocitejCenuRezervace(sender, e);
    }




    /// <summary>
    /// Vypočítá cenu za rezervaci
    /// </summary>
    protected void VypocitejCenuRezervace(object sender, EventArgs e)
    {

        try
        {
            Validate();
            errorLiteral.Visible = false;

            //Načte skibalíček a vypíše info
            CenikSkibalicku skibalicek = SpravceCeniku.NacistCenikSkibalicku(int.Parse(balicekDropDownList.SelectedItem.Value));
            infoKBalickuLiteral.Text = "Balíček " + skibalicek.NazevSkibalicku + " obsahuje " + skibalicek.PocetDniKurzu + " " + GetStringPocetDni(skibalicek.PocetDniKurzu) + " kurzu <em>" + skibalicek.Kurz.NazevKurzu + "</em> a zapůjčení lyžařského vybavení na " + skibalicek.PocetDniVybaveni + " " + GetStringPocetDni(skibalicek.PocetDniVybaveni) + ".";

            //Aktualizace počtu dní
            int pocetDniRezervace = skibalicek.PocetDniVybaveni;
            rezervaceDoTextBox.Text = rezervaceOdCalendar.SelectedDate.AddDays(pocetDniRezervace).ToLongDateString();

            //Vypíše počet osob a slevu za počet osob
            float slevaZaPocetOsob = float.Parse(slevaPocetOsobLiteral.Text);
            if (((Control)sender).ID == "pocetOsobTextBox")
            {
                if (int.Parse(pocetOsobTextBox.Text) <= 0)
                    throw new IndexOutOfRangeException("Špatný zadaný počet osob.");
                pocetOsobLiteral.Text = pocetOsobTextBox.Text + GetStringPocetOsob(int.Parse(pocetOsobTextBox.Text));

                //Vypíše slevu za počet osob
                slevaZaPocetOsob = slevy.VypocitatSlevuZaPocetOsob(int.Parse(pocetOsobTextBox.Text));
                slevaPocetOsobLiteral.Text = slevaZaPocetOsob.ToString();
            }

            //Vypíše slevu za včasnou rezervaci
            float slevaZaVcasnouRezervaci = slevy.VypocitatSlevuZaVcasnouRezervaci((int)(DateTime.Parse(rezervaceOdTextBox.Text) - DateTime.Today).TotalDays);
            slevaTerminLiteral.Text = slevaZaVcasnouRezervaci.ToString();

            //Vypíše slevu za použití partnerského kódu
            float slevaZaPartnerskyKod;
            if (float.TryParse(slevaPartnerskyKodLiteral.Text, out slevaZaPartnerskyKod))
                slevaZaPartnerskyKod = float.Parse(slevaPartnerskyKodLiteral.Text);
            else
                slevaZaPartnerskyKod = 0;

            if (partnerskyKodTextBox.Text != "")
            {
                slevaZaPartnerskyKod = slevy.VypocitatSlevuZaPartnerskyKod(partnerskyKodTextBox.Text);
                if (slevaZaPartnerskyKod == 0)
                    slevaPartnerskyKodLiteral.Text = "XXX - 0";
                else
                    slevaPartnerskyKodLiteral.Text = slevaZaPartnerskyKod.ToString();
            }

            //Vypíše celkovou slevu
            float celkovaSleva = slevy.VypocitatKonecnouSlevu(slevaZaPocetOsob, slevaZaVcasnouRezervaci, slevaZaPartnerskyKod);
            slevaCelkemLiteral.Text = celkovaSleva.ToString();

            //Vypíše cenu rezervace
            float cenaPredSlevou = 0;
            cenaPredSlevou = skibalicek.Cena * int.Parse(pocetOsobTextBox.Text);
            cenaPredSlevouLiteral.Text = cenaPredSlevou.ToString();

            //Vypíše konečnou cenu rezervace
            float cenaKonecna = cenaPredSlevou * (1 - celkovaSleva / 100);
            cenaKonecnaLiteral.Text = cenaKonecna.ToString("f2");

        }
        catch (Exception ex)
        {
            errorLiteral.Visible = true;
            errorLiteral.Text = ex.Message;
        }
    }

    /// <summary>
    /// Vrátí slovo den ve správném pádě podle počtu
    /// </summary>
    /// <param name="pocet">Počet dní</param>
    /// <returns>Slovo den ve správném pádě</returns>
    private string GetStringPocetDni(int pocet)
    {
        if (pocet == 1)
            return " den";
        else if (pocet < 5)
            return " dny";
        else
            return " dní";
    }

    /// <summary>
    /// Vrátí slovo osoba ve správném pádě podle počtu
    /// </summary>
    /// <param name="pocet">Počet osob</param>
    /// <returns>Slovo pád ve správném pádě</returns>
    private string GetStringPocetOsob(int pocet)
    {
        if (pocet == 1)
            return " osobu";
        else if (pocet < 5)
            return " osoby";
        else
            return " osob";
    }

    protected void pokracovatButton_Click(object sender, EventArgs e)
    {
        //Vypnutí panelů termínů
        terminPanel.Enabled = false;
        terminControlPanel.Visible = false;

        //Zaptnutí panelů setů
        setyPanel.Visible = true;
        setyControlPanel.Visible = true;

    }


    protected void upravitButton_Click(object sender, EventArgs e)
    {
        //Vypnutí panelů setů
        setyPanel.Visible = false;
        setyControlPanel.Visible = false;

        //Zapnutí panelů termínů
        terminPanel.Enabled = true;
        terminControlPanel.Visible = true;


    }


    protected void potvrditButton_Click(object sender, EventArgs e)
    {
        string partnerskyKod;
        if (slevaPartnerskyKodLiteral.Text == "0")
            partnerskyKod = "";
        else
            partnerskyKod = partnerskyKodTextBox.Text;

        ArrayList seznamPolozek = new ArrayList();

        for (int i = 0; i < int.Parse(pocetOsobTextBox.Text); i++)
        {
            DropDownList setDropDownList = (DropDownList)setyPanel.FindControl("set" + i.ToString() + "DropDownList");
            TextBox vyskaTextBox = (TextBox)setyPanel.FindControl("vyska" + i.ToString() + "TextBox");
            TextBox vahaTextBox = (TextBox)setyPanel.FindControl("vaha" + i.ToString() + "TextBox");
            TextBox botaTextBox = (TextBox)setyPanel.FindControl("velikostBoty" + i.ToString() + "TextBox");

            RezervaceLyzarskehoVybaveniPolozky polozka = new RezervaceLyzarskehoVybaveniPolozky(setDropDownList.SelectedItem.Text, int.Parse(vyskaTextBox.Text), int.Parse(vahaTextBox.Text), float.Parse(botaTextBox.Text), 0);
            seznamPolozek.Add(polozka);
        }

        Slevy slevy = new Slevy();
        slevy.OnLineRezervace = float.Parse(slevaOnlineLiteral.Text);
        slevy.VcasnaRezervace = float.Parse(slevaTerminLiteral.Text);
        slevy.SlevaPocetOsob = float.Parse(slevaPocetOsobLiteral.Text);
        slevy.PouzitiPartnerskehoKodu = float.Parse(slevaPartnerskyKodLiteral.Text);
        slevy.MaximalniSleva = float.Parse(slevaCelkemLiteral.Text);

        if (SpravceRezervaci.VytvoritRezervaciSkibalicku(new Zakaznik(Profile.userId), new Pobocka(int.Parse(pobockaDropDownList.SelectedItem.Value)), partnerskyKod,
            float.Parse(cenaPredSlevouLiteral.Text), slevy, float.Parse(cenaKonecnaLiteral.Text),
            DateTime.Parse(rezervaceOdTextBox.Text), DateTime.Parse(rezervaceDoTextBox.Text), int.Parse(pocetOsobTextBox.Text), balicekDropDownList.SelectedItem.Text, preferovanyInstruktorDropDownList.SelectedItem.Value, seznamPolozek, poznamkaTextBox.Text))
            Response.Redirect("RezervacePotvrzeni.aspx");
        else
        {
            errorLiteral.Visible = true;
            errorLiteral.Text = "Při ukládání rezervace došlo k chybě. Kontaktujte prosím provozovatele.";
        }


    }

    protected void portvrditRezervaciButton_Click(object sender, EventArgs e)
    {
        //Vypnutí panelů sety
        setyPanel.Enabled = false;
        setyControlPanel.Visible = false;

        //Zapnutí panelů dokončení rezervace
        dokoncitRezervaciControlPanel.Visible = true;

        VypocitejCenuRezervace(sender, e);
    }

    protected void balicekDropDownList_SelectedIndexChanged(object sender, EventArgs e)
    {
        VypocitejCenuRezervace(sender, e);
    }


    protected void upravitSetyButton_Click(object sender, EventArgs e)
    {
        //Zapnutí panelů setů
        setyPanel.Enabled = true;
        setyControlPanel.Visible = true;

        //Vyputí panelu dokončení
        dokoncitRezervaciControlPanel.Visible = false;
    }

    protected void preferovanyInstruktorDropDownList_DataBound(object sender, EventArgs e)
    {
        ListItem newListItem = new ListItem("-", "");
        newListItem.Selected = true;
        preferovanyInstruktorDropDownList.Items.Add(newListItem);
    }
}