﻿<%@ Page Language="C#" MasterPageFile="~/RezervacniSystemMasterPage.master" AutoEventWireup="true"
    CodeFile="Provize.aspx.cs" Inherits="admin_Provize" Title="Správa provizí" %>

<asp:Content ID="Content1" ContentPlaceHolderID="head" runat="Server">
</asp:Content>
<asp:Content ID="Content2" ContentPlaceHolderID="obsahStranky" runat="Server">
    <h1>
        Správa provizí
    </h1>
    <asp:Panel ID="prehledProviziPanel" runat="server">
        <p>
            Provize mohou být přiznány ke všem rezervacím u kterých byl použit platný klientský
            kód.
        </p>
        <asp:GridView ID="provizeGridView" runat="server" AutoGenerateColumns="False" CellPadding="2"
            DataSourceID="provizeObjectDataSource" ForeColor="White" GridLines="None" Width="580px"
            AllowPaging="True">
            <Columns>
                <asp:BoundField DataField="idRezervace" HeaderText="Id rezervace" SortExpression="idRezervace" />
                <asp:BoundField DataField="prijmeni" HeaderText="Partner" SortExpression="prijmeni" />
                <asp:BoundField DataField="partnerskyKod" HeaderText="Partnerský kód" SortExpression="partnerskyKod" />
                <asp:BoundField DataField="cenaKonecna" HeaderText="Cena rezervace" SortExpression="cenaKonecna"
                    DataFormatString="{0:f2} Kč">
                    <ItemStyle HorizontalAlign="Right" />
                </asp:BoundField>
                <asp:BoundField DataField="datumVyplaceni" DataFormatString="{0:dd.MM.yyyy}" HeaderText="Datum vyplacení"
                    NullDisplayText="nevyplaceno" SortExpression="datumVyplaceni" />
                <asp:BoundField DataField="provize" DataFormatString="{0:f2} Kč" HeaderText="Výše provize"
                    NullDisplayText="-" SortExpression="provize" />
                <asp:HyperLinkField DataNavigateUrlFields="idRezervace" DataNavigateUrlFormatString="?action=set&amp;idRezervace={0}"
                    HeaderText="nastavit" Text="nastavit" />
            </Columns>
            <FooterStyle BackColor="Tan" />
            <PagerStyle BackColor="#ffff00" ForeColor="Black" HorizontalAlign="Center" />
            <HeaderStyle BackColor="#ffff00" Font-Bold="True" ForeColor="Black" />
            <AlternatingRowStyle BackColor="#4a3f40" />
        </asp:GridView>
        <asp:ObjectDataSource ID="provizeObjectDataSource" runat="server" SelectMethod="NacistSeznamProvizi"
            TypeName="SpravceRezervaci"></asp:ObjectDataSource>
    </asp:Panel>
    <asp:Panel ID="nastaveniPanel" runat="server" Visible="false">
        <h2>
            Nastavení provize rezervace č.
            <asp:Literal ID="cisloRezervaceLiteral" runat="server"></asp:Literal>
        </h2>
        <table style="width: 100%">
            <tr>
                <th>
                    Partner:
                </th>
                <td>
                    <asp:Literal ID="partnerLiteral" runat="server"></asp:Literal>
                </td>
            </tr>
            <tr>
                <th>
                    Výše provize:
                </th>
                <td>
                    <asp:TextBox ID="vyseProvizeTextBox" CssClass="alignRight" runat="server"></asp:TextBox>
                    Kč (
                    <asp:TextBox ID="procentaProvizeTextBox" Width="20" runat="server">10</asp:TextBox>% z celkové ceny
                    <asp:Button ID="vypocitatProviziButton" runat="server" Text="vypočítat" 
                        onclick="vypocitatProviziButton_Click" />
                    )
                </td>
            </tr>
            <tr>
                <th>
                    Zaplaceno:
                </th>
                <td>
                    <asp:RadioButtonList ID="zaplacenoRadioButtonList" runat="server" AutoPostBack="True"
                        RepeatDirection="Horizontal" RepeatLayout="Flow">
                        <asp:ListItem Selected="True">ne</asp:ListItem>
                        <asp:ListItem>ano</asp:ListItem>
                    </asp:RadioButtonList>
                </td>
            </tr>
            <asp:Panel ID="datumPanel" runat="server">
                <tr>
                    <th>
                        Datum zaplacení:
                    </th>
                    <td>
                        <asp:TextBox ID="datumZaplaceniTextBox" ReadOnly="true" runat="server"></asp:TextBox>
                        <asp:Button ID="datumZaplaceniButton" runat="server" Text="+" OnClick="datumZaplaceniButton_Click" />
                        <asp:Calendar ID="datumZaplaceniCalendar" Visible="false" runat="server" OnSelectionChanged="datumZaplaceniCalendar_SelectionChanged">
                        </asp:Calendar>
                    </td>
                </tr>
            </asp:Panel>
            <tr>
                <th>
                    Poznámka:
                </th>
                <td>
                    <asp:TextBox ID="poznamkaTextBox" TextMode="MultiLine" Width="400" Height="100" runat="server"></asp:TextBox>
                </td>
            </tr>
            <tr>
                <th colspan="2">
                    <asp:Button ID="ulozButton" runat="server" Text="Uložit změny" OnClick="ulozButton_Click" />
                </th>
            </tr>
        </table>
        <h2>
            Informace o rezervaci
        </h2>
        <table style="width: 100%">
            <tr style="border-bottom: 3px solid gray;">
                <th>
                    Stav rezervace:
                </th>
                <td>
                    <asp:Literal ID="stavLiteral" runat="server"></asp:Literal>
                </td>
                <td class="rezervaceCeny">
                    online sleva
                    <asp:Literal ID="slevaOnlineLiteral" runat="server">0</asp:Literal>
                    %
                </td>
            </tr>
            <tr>
                <th>
                    Termín rezervace:
                </th>
                <td>
                    <asp:Literal ID="terminRezervaceDoLiteral" runat="server"></asp:Literal>
                </td>
                <td class="rezervaceCeny">
                    <asp:Literal ID="slevaTerminLiteral" runat="server" Text="0"></asp:Literal>
                    %
                </td>
            </tr>
            <tr>
                <th>
                    Pobočka:
                </th>
                <td>
                    <asp:Literal ID="pobockaLiteral" runat="server"></asp:Literal>
                </td>
            </tr>
            <tr>
                <th>
                    Partnerský kód:
                </th>
                <td>
                    <asp:Literal ID="partnerskyKodLiteral" runat="server"></asp:Literal>
                </td>
                <td class="rezervaceCeny">
                    <asp:Literal ID="slevaPartnerskyKodLiteral" runat="server" Text="0"></asp:Literal>
                    %
                </td>
            </tr>
            <tr style="border-bottom: 3px solid gray;">
                <th>
                    Jiné sdělení:
                </th>
                <td colspan="2">
                    <asp:Literal ID="poznamkaLiteral" runat="server"></asp:Literal>
                </td>
            </tr>
            <tr style="border-top: 3px solid gray;">
                <th colspan="2">
                    Cena před slevou
                </th>
                <th style="text-align: right;">
                    <asp:Literal ID="cenaPredSlevouLiteral" runat="server" Text="0"></asp:Literal>
                    Kč
                </th>
            </tr>
            <tr>
                <th colspan="2">
                    Sleva celkem
                </th>
                <th style="text-align: right;">
                    <asp:Literal ID="slevaCelkemLiteral" runat="server" Text="4"></asp:Literal>
                    %
                </th>
            </tr>
            <tr class="rezervaceSumCena">
                <th colspan="2">
                    Konečná cena
                </th>
                <th style="text-align: right;">
                    <asp:Literal ID="cenaKonecnaLiteral" runat="server" Text="0"></asp:Literal>
                    Kč
                </th>
            </tr>
        </table>
    </asp:Panel>
</asp:Content>
