﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;

public partial class admin_Provize : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {

        if (Request.QueryString["action"] != null)
        {
            prehledProviziPanel.Visible = false;
            nastaveniPanel.Visible = true;

            Rezervace rezervace = SpravceRezervaci.NacistRezervaci(int.Parse(Request.QueryString["idRezervace"]));
            VypisUdajeORezervaci(rezervace);
            Provize provize = SpravceRezervaci.NacistProvizi(rezervace);
            VypisDatumVyplaceniProvize(provize);
            if (!Page.IsPostBack)
            {
                VypisUdajeOProvizi(provize);
            }
        }

    }


    protected void VypisUdajeOProvizi(Provize provize)
    {

        partnerLiteral.Text = provize.Partner.Jmeno + " " + provize.Partner.Prijmeni;
        vyseProvizeTextBox.Text = provize.VyseProvize.ToString("f2");

        poznamkaTextBox.Text = provize.Poznamka;

    }

    protected void VypisDatumVyplaceniProvize(Provize provize)
    {
        if (provize.DatumVyplaceni != DateTime.MinValue)
        {
            zaplacenoRadioButtonList.Items.FindByText("ano").Selected = true;
            datumPanel.Visible = true;
            datumZaplaceniCalendar.SelectedDate = provize.DatumVyplaceni;
            datumZaplaceniCalendar.VisibleDate = provize.DatumVyplaceni;
            datumZaplaceniTextBox.Text = provize.DatumVyplaceni.ToLongDateString();
        }
        else
            if (zaplacenoRadioButtonList.SelectedItem.Text == "ano")
            {
                datumPanel.Visible = true;
                datumZaplaceniCalendar.SelectedDate = DateTime.Today;
                datumZaplaceniTextBox.Text = datumZaplaceniCalendar.SelectedDate.ToLongDateString();
            }
            else
                datumPanel.Visible = false;
    }

    /// <summary>
    /// Vypíše údaje o rezervaci.
    /// </summary>
    /// <param name="rezervace">Rezervace.</param>
    protected void VypisUdajeORezervaci(Rezervace rezervace)
    {
        cisloRezervaceLiteral.Text = rezervace.ReferencniCislo.ToString();

        stavLiteral.Text = rezervace.StavRezervace.NazevStavuRezervace;
        slevaOnlineLiteral.Text = rezervace.Slevy.OnLineRezervace.ToString();
        terminRezervaceDoLiteral.Text = rezervace.ZacatekRezervace.ToLongDateString() + " - " + rezervace.KonecRezervace.ToLongDateString();
        slevaTerminLiteral.Text = rezervace.Slevy.VcasnaRezervace.ToString();
        pobockaLiteral.Text = rezervace.Pobocka.NazevPobocky;
        partnerskyKodLiteral.Text = rezervace.PartnerskyKod;
        slevaPartnerskyKodLiteral.Text = rezervace.Slevy.PouzitiPartnerskehoKodu.ToString();
        poznamkaLiteral.Text = rezervace.Poznamka;

        cenaPredSlevouLiteral.Text = rezervace.CenaPredSlevou.ToString("f2");
        slevaCelkemLiteral.Text = rezervace.Slevy.MaximalniSleva.ToString();
        cenaKonecnaLiteral.Text = rezervace.CenaKonecna.ToString("f2");
    }


    protected void datumZaplaceniButton_Click(object sender, EventArgs e)
    {
        if (datumZaplaceniCalendar.Visible == true)
        {
            datumZaplaceniCalendar.Visible = false;
            datumZaplaceniButton.Text = "+";
        }
        else
        {
            datumZaplaceniCalendar.Visible = true;
            datumZaplaceniButton.Text = "-";
        }
    }


    protected void datumZaplaceniCalendar_SelectionChanged(object sender, EventArgs e)
    {
        datumZaplaceniTextBox.Text = datumZaplaceniCalendar.SelectedDate.ToLongDateString();
        datumZaplaceniCalendar.Visible = false;
        datumZaplaceniButton.Text = "+";
    }

    protected void ulozButton_Click(object sender, EventArgs e)
    {
        DateTime datumVyplaceni = DateTime.MinValue;
        if (zaplacenoRadioButtonList.SelectedItem.Text == "ano")
            datumVyplaceni = datumZaplaceniCalendar.SelectedDate;

        Provize provize = new Provize(float.Parse(vyseProvizeTextBox.Text), datumVyplaceni, poznamkaTextBox.Text, null, new Rezervace(int.Parse(cisloRezervaceLiteral.Text), null));
        provize.Ulozit();
        Response.Redirect("Provize.aspx");
    }

    protected void vypocitatProviziButton_Click(object sender, EventArgs e)
    {
        Rezervace rezervace = SpravceRezervaci.NacistRezervaci(int.Parse(Request.QueryString["idRezervace"]));
        VypisUdajeORezervaci(rezervace);
        Provize provize = SpravceRezervaci.NacistProvizi(rezervace);

        vyseProvizeTextBox.Text = Math.Round((rezervace.CenaKonecna * (float.Parse(procentaProvizeTextBox.Text) / 100)), 1).ToString("f2");

    }
}
