﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;

public partial class admin_Rezervace : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (Request.QueryString["action"] != null)
        {
            prehledRezervaciPanel.Visible = false;
            detailPanel.Visible = true;

            if (!Page.IsPostBack)
            {
                RezervaceLyzarskehoKurzu lyzarskyKurz = SpravceRezervaci.NacistRezervaciLyzarskehoKurzu(int.Parse(Request.QueryString["id"]));
                RezervaceLyzarskehoVybaveni lyzarskeVybaveni = SpravceRezervaci.NacistRezervaciLyzarskehoVybaveni(int.Parse(Request.QueryString["id"])); ;
                if (lyzarskyKurz != null)
                {
                    VypisUdajeORezervaci(lyzarskyKurz);
                    VypisUdajeORezervaciLyzarskehoKurzu(lyzarskyKurz);
                }
                else
                {
                    noRezervaceLyzarskyKurzLabel.Visible = true;
                    rezervaceLyzarskehoKurzuPanel.Visible = false;
                }
                if (lyzarskeVybaveni != null)
                {
                    lyzarskeVybaveniPanel.Visible = true;
                    VypisUdajeORezervaci(lyzarskeVybaveni);
                    VypisUdajeORezervaciLyzarskehoVybaveni(lyzarskeVybaveni);
                }
                else
                {
                    lyzarskeVybaveniPanel.Visible = false;
                }


            }

        }
    }

    /// <summary>
    /// Vypíše údaje o rezervaci.
    /// </summary>
    /// <param name="rezervace">Rezervace.</param>
    protected void VypisUdajeORezervaci(Rezervace rezervace)
    {
        //Stav rezervace
        stavRezervaceDropDownList.DataBind();
        stavRezervaceDropDownList.Items.FindByText(rezervace.StavRezervace.NazevStavuRezervace).Selected = true;

        //Zákazník
        zakaznikLiteral.Text = "<strong>" + rezervace.Zakaznik.Jmeno + " " + rezervace.Zakaznik.Prijmeni + "</strong ><br />" +
            rezervace.Zakaznik.FakturacniAdresa.Ulice + ", " + rezervace.Zakaznik.FakturacniAdresa.Mesto + ", " + rezervace.Zakaznik.FakturacniAdresa.Psc + "<br />" +
            rezervace.Zakaznik.Email + ", " + rezervace.Zakaznik.TelefonniCislo;


        //Termín rezervace
        rezervaceOdCalendar.SelectedDate = rezervace.ZacatekRezervace;
        rezervaceOdTextBox.Text = rezervaceOdCalendar.SelectedDate.ToLongDateString();
        rezervaceDoCalendar.SelectedDate = rezervace.KonecRezervace;
        rezervaceDoTextBox.Text = rezervaceDoCalendar.SelectedDate.ToLongDateString();

        //Sleva termín
        slevaTerminTextBox.Text = rezervace.Slevy.VcasnaRezervace.ToString("f2");

        //Pobočka
        pobockaDropDownList.DataBind();
        pobockaDropDownList.Items.FindByValue(rezervace.Pobocka.IdPobocky.ToString()).Selected = true;

        //Partnerský kód
        partnerskyKodTextBox.Text = rezervace.PartnerskyKod;
        slevaPartnerskyKodTextBox.Text = rezervace.Slevy.PouzitiPartnerskehoKodu.ToString("f2");

        //Poznamky
        jineSdeleniTextBoxLiteral.Text = rezervace.JineSdeleni;
        poznamkaAdminTextBox.Text = rezervace.Poznamka;

        //Slevy
        slevaPocetTextBox.Text = rezervace.Slevy.SlevaPocetOsob.ToString("f2");
        slevaOnlineTextBox.Text = rezervace.Slevy.OnLineRezervace.ToString("f2");
        slevaCelkemTextBox.Text = rezervace.Slevy.MaximalniSleva.ToString("f2");

        //Ceny
        cenaPredSlevouTextBox.Text = rezervace.CenaPredSlevou.ToString("f2");
        konecnaCenaTextBox.Text = rezervace.CenaKonecna.ToString("f2");
    }

    /// <summary>
    /// Vypíše údaje o rezervaci lyžařského vybavení.
    /// </summary>
    /// <param name="lyzarskeVybaveni">Rezervace lyžařského vybavení.</param>
    protected void VypisUdajeORezervaciLyzarskehoVybaveni(RezervaceLyzarskehoVybaveni lyzarskeVybaveni)
    {
        int i = 1;
        lyzarskeVybaveniPanel.Visible = true;
        foreach (RezervaceLyzarskehoVybaveniPolozky polozka in lyzarskeVybaveni.SeznamPolozek)
        {
            TableRow tr = new TableRow();

            TableCell td = new TableCell();
            td.Text = i + ". " + polozka.Typ;
            tr.Cells.Add(td);

            td = new TableCell();
            td.Text = polozka.Vyska + " cm, " + polozka.Vaha + " kg, " + polozka.VelikostBoty;
            tr.Cells.Add(td);

            td = new TableCell();
            td.HorizontalAlign = HorizontalAlign.Right;
            if (polozka.Cena == 0)
                td.Text = "v ceně balíčku";
            else
                td.Text = polozka.Cena.ToString("f2") + "&nbsp;Kč";
            tr.Cells.Add(td);

            lyzarskeVybaveniTable.Rows.Add(tr);
            i++;
        }
    }

    /// <summary>
    /// Vypíše údaje o rezervaci lyžařského kurzu.
    /// </summary>
    /// <param name="RezervaceLyzarskehoKurzu">Rezervace lyžařského kurzu.</param>
    protected void VypisUdajeORezervaciLyzarskehoKurzu(RezervaceLyzarskehoKurzu rezervace)
    {
        //Kurz
        typKurzuDropDownList.DataBind();
        if (typKurzuDropDownList.Items.FindByText(rezervace.Kurz) != null)
            typKurzuDropDownList.Items.FindByText(rezervace.Kurz).Selected = true;

        //Počet osob
        pocetOsobTextBox.Text = rezervace.PocetOsob.ToString();

        //Zpětné hodnocení
        zpětneHodnoceniLiteral.Text = rezervace.ZpetneHodnoceni;
        if (zpětneHodnoceniLiteral.Text == "")
            zpětneHodnoceniLiteral.Text = "-";

        //Preferovaný instruktor
        preferovanyInstruktorLiteral.Text = rezervace.PreferovanyInstruktor.Jmeno + " " + rezervace.PreferovanyInstruktor.Prijmeni;
        if (preferovanyInstruktorLiteral.Text == "")
            preferovanyInstruktorLiteral.Text = "nezadán";

        //Skutečný instruktor
        if (rezervace.SkutecnyInstruktor != null)
            skutecnyInstruktorDropDownList.Items.FindByValue(rezervace.SkutecnyInstruktor.Id);


    }



    /// <summary>
    /// Strisknutí tlačítka rezervace od
    /// </summary>
    protected void rezervaceOdButton_Click(object sender, EventArgs e)
    {
        if (rezervaceOdCalendar.Visible == true)
        {
            rezervaceOdCalendar.Visible = false;
            rezervaceOdButton.Text = "+";
        }
        else
        {
            rezervaceOdCalendar.Visible = true;
            rezervaceOdButton.Text = "-";
        }
    }

    /// <summary>
    /// Změna výběru data konce kalednáře
    /// </summary>
    protected void rezervaceOdCalendar_SelectionChanged(object sender, EventArgs e)
    {
        if (rezervaceOdCalendar.SelectedDate < DateTime.Today.AddDays(1))
            rezervaceOdCalendar.SelectedDate = DateTime.Today.AddDays(1);

        rezervaceOdTextBox.Text = rezervaceOdCalendar.SelectedDate.ToLongDateString();
        rezervaceOdCalendar.Visible = false;
        rezervaceOdButton.Text = "+";
        if (rezervaceDoCalendar.SelectedDate < rezervaceOdCalendar.SelectedDate)
        {
            rezervaceDoCalendar.SelectedDate = rezervaceOdCalendar.SelectedDate.AddDays(1);
            rezervaceDoCalendar.VisibleDate = rezervaceOdCalendar.SelectedDate.AddDays(1);
            rezervaceDoTextBox.Text = rezervaceDoCalendar.SelectedDate.ToLongDateString();
        }
    }

    /// <summary>
    /// Stisknutí tlačíka rezervace do
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void rezervaceDoButton_Click(object sender, EventArgs e)
    {
        if (rezervaceDoCalendar.Visible == true)
        {
            rezervaceDoCalendar.Visible = false;
            rezervaceDoButton.Text = "+";
        }
        else
        {
            rezervaceDoCalendar.Visible = true;
            rezervaceDoButton.Text = "-";
            rezervaceDoCalendar.SelectedDate = DateTime.Parse(rezervaceDoTextBox.Text);
        }
    }

    /// <summary>
    /// Změna výběru data začátku rezervace
    /// </summary>
    protected void rezervaceDoCalendar_SelectionChanged(object sender, EventArgs e)
    {
        if (rezervaceDoCalendar.SelectedDate > rezervaceOdCalendar.SelectedDate)
        {
            rezervaceDoTextBox.Text = rezervaceDoCalendar.SelectedDate.ToLongDateString();
        }
        rezervaceDoCalendar.Visible = false;
        rezervaceDoButton.Text = "+";
    }


    protected void zpetButton_Click(object sender, EventArgs e)
    {
        Response.Redirect("Rezervace.aspx");
    }

    /// <summary>
    /// Uloží změny v rezervaci.
    /// </summary>
    protected void ulozitRezervaciButton_Click(object sender, EventArgs e)
    {
        try
        {
            Rezervace rezervace = SpravceRezervaci.NacistRezervaci(int.Parse(Request.QueryString["id"]));

            rezervace.StavRezervace.IdStavuRezervace = int.Parse(stavRezervaceDropDownList.SelectedItem.Value);
            rezervace.ZacatekRezervace = rezervaceOdCalendar.SelectedDate;
            rezervace.KonecRezervace = rezervaceDoCalendar.SelectedDate;
            rezervace.Pobocka.IdPobocky = int.Parse(pobockaDropDownList.SelectedItem.Value);
            rezervace.PartnerskyKod = partnerskyKodTextBox.Text;
            rezervace.Slevy.VcasnaRezervace = float.Parse(slevaTerminTextBox.Text);
            rezervace.Slevy.PouzitiPartnerskehoKodu = float.Parse(slevaPartnerskyKodTextBox.Text);
            rezervace.Slevy.SlevaPocetOsob = float.Parse(slevaPocetTextBox.Text);
            rezervace.Slevy.OnLineRezervace = float.Parse(slevaOnlineTextBox.Text);
            rezervace.Slevy.MaximalniSleva = float.Parse(slevaCelkemTextBox.Text);
            rezervace.CenaPredSlevou = float.Parse(cenaPredSlevouTextBox.Text);
            rezervace.CenaKonecna = float.Parse(konecnaCenaTextBox.Text);
            rezervace.JineSdeleni = jineSdeleniTextBoxLiteral.Text;
            rezervace.Poznamka = poznamkaAdminTextBox.Text;

            rezervace.UlozitRezervaci();

            ulozeniRezervaceInfoLabel.Text = "Změny úspěšně uloženy.";
            ulozeniRezervaceInfoLabel.CssClass = "poznamka";
        }
        catch (Exception)
        {
            ulozeniRezervaceInfoLabel.Text = "Při ukládání nastala chyba. Zkontrolujte všechna pole.";
            ulozeniRezervaceInfoLabel.CssClass = "error";
        }
    }

    /// <summary>
    /// Přidá do seznamu skutečných instruktorů prázdné pole.
    /// </summary>
    protected void SkutecnyInstruktorDropDownList_DataBound(object sender, EventArgs e)
    {
        ListItem newListItem = new ListItem("-", "");
        newListItem.Selected = true;
        skutecnyInstruktorDropDownList.Items.Add(newListItem);
    }
    protected void ulozitRezervaciLyzarskeVyukyButton_Click(object sender, EventArgs e)
    {
        try
        {
            RezervaceLyzarskehoKurzu rezervace = SpravceRezervaci.NacistRezervaciLyzarskehoKurzu(int.Parse(Request.QueryString["id"]));

            rezervace.PocetOsob = int.Parse(pocetOsobTextBox.Text);
            rezervace.Kurz = typKurzuDropDownList.SelectedItem.Text;
            rezervace.SkutecnyInstruktor.Id = skutecnyInstruktorDropDownList.SelectedItem.Value;

            rezervace.UlozitRezervaci();

            ulozeniRezervaceLyzarskeVyukyInfoLabel.Text = "Změny úspěšně uloženy.";
            ulozeniRezervaceLyzarskeVyukyInfoLabel.CssClass = "poznamka";
        }
        catch (Exception)
        {
            ulozeniRezervaceLyzarskeVyukyInfoLabel.Text = "Při ukládání nastala chyba. Zkontrolujte všechna pole.";
            ulozeniRezervaceLyzarskeVyukyInfoLabel.CssClass = "error";
        }
    }
}
