﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;

public partial class admin_RezervaceStavy : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (Request.QueryString["action"] == "new")
        {
            seznamPanel.Visible = false;
            detailPanel.Visible = true;
            h2DetailLiteral.Text = "Nový stav rezervace";
        }
        else if (Request.QueryString["action"] == "update")
        {
            seznamPanel.Visible = false;
            detailPanel.Visible = true;
            h2DetailLiteral.Text = "Upravit stav rezervace";

            if (!Page.IsPostBack)
            {
                VypisStavRezervace(int.Parse(Request.QueryString["id"]));
            }
        }
        else if (Request.QueryString["action"] == "delete")
        {
            seznamPanel.Visible = false;
            detailPanel.Visible = true;
            polozkyPanel.Enabled = false;
            h2DetailLiteral.Text = "Opravdu se má stav rezervace smazat?";
            if (!Page.IsPostBack)
            {
                VypisStavRezervace(int.Parse(Request.QueryString["id"]));
            }
        }
        else
        {
            seznamPanel.Visible = true;
            detailPanel.Visible = false;
        }

    }



    /// <summary>
    /// Vypíše stav rezervace.
    /// </summary>
    /// <param name="idStavuRezervace">Id stavu rezervace.</param>    
    protected void VypisStavRezervace(int idStavuRezervace)
    {
        RezervaceStav stavRezervace = SpravceRezervaci.NacistStavRezervace(idStavuRezervace);
        idLiteral.Text = stavRezervace.IdStavuRezervace.ToString();
        stavRezervaceTextBox.Text = stavRezervace.NazevStavuRezervace;
        infoTextBox.Text = stavRezervace.Informace;

        if (idStavuRezervace == -1)
        {
            stavRezervaceTextBox.ReadOnly = true;
        }
    }

    /// <summary>
    /// Smazání stavu rezervace.
    /// </summary>
    protected void potvrdButton_Click(object sender, EventArgs e)
    {

        if (Request.QueryString["action"] == "delete")
        {
            if (!SpravceRezervaci.SmazatStavRezervace(int.Parse(idLiteral.Text)))
            {
                errorLiteral.Text = "Chyba při mazání stavu rezervace.";
                return;
            }
        }
        else
        {
            if (!SpravceRezervaci.UlozitStavRezervace(int.Parse(idLiteral.Text), stavRezervaceTextBox.Text, infoTextBox.Text))
            {
                errorLiteral.Text = "Chyba při ukládání.";
                return;
            }
        }

        Response.Redirect("RezervaceStavy.aspx");
    }


    /// <summary>
    /// Vrátí se zpět na přehled stavů rezervací.
    /// </summary>
    protected void zpetButton_Click(object sender, EventArgs e)
    {
        Response.Redirect("RezervaceStavy.aspx");
    }
    protected void stavyGridView_RowDataBound(object sender, GridViewRowEventArgs e)
    {
        try
        {
            int id = int.Parse(e.Row.Cells[0].Text);
            if (id == -1)
            {
                e.Row.Cells[4].Text = "nelze smazat";
            }
        }
        catch (Exception)
        {
        }
    }
}
