﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;

public partial class admin_Skibalicky : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (Request.QueryString["action"] == "new")
        {
            seznamPanel.Visible = false;
            detailPanel.Visible = true;
            h2DetailLiteral.Text = "Nový skibalíček";
        }
        else if (Request.QueryString["action"] == "update")
        {
            seznamPanel.Visible = false;
            detailPanel.Visible = true;
            h2DetailLiteral.Text = "Upravit skibalíček";

            if (!Page.IsPostBack)
            {
                VypisSkibalicek(int.Parse(Request.QueryString["id"]));
            }
        }
        else if (Request.QueryString["action"] == "delete")
        {
            seznamPanel.Visible = false;
            detailPanel.Visible = true;
            polozkyPanel.Enabled = false;
            h2DetailLiteral.Text = "Opravdu se má skibalíček smazat?";
            if (!Page.IsPostBack)
            {
                VypisSkibalicek(int.Parse(Request.QueryString["id"]));
            }
        }
        else
        {
            seznamPanel.Visible = true;
            detailPanel.Visible = false;
        }
    }

    protected void VypisSkibalicek(int idSkibalicku)
    {
        CenikSkibalicku skibalicek = SpravceCeniku.NacistCenikSkibalicku(idSkibalicku);
        idLiteral.Text = skibalicek.IdSkibalicku.ToString();
        nazevTextBox.Text = skibalicek.NazevSkibalicku;
        typKurzuDropDownList.DataBind();
        typKurzuDropDownList.Items.FindByValue(skibalicek.Kurz.IdKurzu.ToString()).Selected = true;
        pocetDniKurzuTextBox.Text = skibalicek.PocetDniKurzu.ToString();
        pocetDniVybaveniTextBox.Text = skibalicek.PocetDniVybaveni.ToString();
        cenaKlientTextBox.Text = skibalicek.Cena.ToString("f2");
    }

    protected void potvrdButton_Click(object sender, EventArgs e)
    {

        if (Request.QueryString["action"] == "delete")
        {
            if (!SpravceCeniku.SmazatCenikSkibalicku(int.Parse(idLiteral.Text)))
            {
                errorLiteral.Text = "Chyba při mazání skibalíčku.";
                return;
            }
        }
        else
            if (!SpravceCeniku.UlozitCenikSkibalicku(int.Parse(idLiteral.Text), nazevTextBox.Text, int.Parse(typKurzuDropDownList.SelectedItem.Value), int.Parse(pocetDniKurzuTextBox.Text), int.Parse(pocetDniVybaveniTextBox.Text), float.Parse(cenaKlientTextBox.Text)))
            {
                errorLiteral.Text = "Chyba při ukládání.";
                return;
            }
        Response.Redirect("Skibalicky.aspx");
    }


    protected void zpetButton_Click(object sender, EventArgs e)
    {
        Response.Redirect("Skibalicky.aspx");
    }
}
