﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;

public partial class admin_Slevy : System.Web.UI.Page
{

    protected void Page_Load(object sender, EventArgs e)
    {
        //Pokud se mají vytvořit nové slevy
        if (Request.QueryString["action"] == "new")
        {
            seznamPanel.Visible = false;
            detailPanel.Visible = true;
            h2DetailLiteral.Text = "Nové slevy";
        }
        //Pokud se mají slevy upravit
        else if (Request.QueryString["action"] == "update")
        {
            seznamPanel.Visible = false;
            detailPanel.Visible = true;
            h2DetailLiteral.Text = "Upravit slevy";

            if (!Page.IsPostBack)
            {
                VypisSlevy(int.Parse(Request.QueryString["id"]));
            }
        }
        //Pokud se slevy mají smazat
        else if (Request.QueryString["action"] == "delete")
        {
            seznamPanel.Visible = false;
            detailPanel.Visible = true;
            polozkyPanel.Enabled = false;
            h2DetailLiteral.Text = "Opravdu se mají slevy smazat?";
            if (!Page.IsPostBack)
            {
                VypisSlevy(int.Parse(Request.QueryString["id"]));
            }
        }
        else
        {
            seznamPanel.Visible = true;
            detailPanel.Visible = false;
        }
        //Vypíše při PostBacku dynamické řádky
        if (Page.IsPostBack)
        {
            for (int i = 0; i < int.Parse(pocetRozsahuTextBox.Text); i++)
            {
                VytvorDynamickyRadek(i, "", "");
            }
        }
    }

    /// <summary>
    /// Vypíše slevy.
    /// </summary>
    /// <param name="idSlevy">Id slev, které se mají vypsat.</param>
    protected void VypisSlevy(int idSlevy)
    {
        Slevy slevy = SpravceCeniku.NacistSlevy(idSlevy);
        idLiteral.Text = idSlevy.ToString();
        platnostOdCalendar.SelectedDate = slevy.PlatnostOd;
        platnostOdCalendar.VisibleDate = slevy.PlatnostOd;
        platnostOdTextBox.Text = slevy.PlatnostOd.ToLongDateString();

        onlineTextBox.Text = slevy.OnLineRezervace.ToString("f2");
        partnerskyKodTextBox.Text = slevy.PouzitiPartnerskehoKodu.ToString("f2");
        vcasnaRezervaceTextBox.Text = slevy.VcasnaRezervace.ToString("f2");
        slevaMaxTextBox.Text = slevy.MaximalniSleva.ToString("f2");

        pocetRozsahuTextBox.Text = slevy.SlevyPocetOsob.Count.ToString();

        for (int i = 0; i < int.Parse(pocetRozsahuTextBox.Text); i++)
        {
            string idControl = "pocetOsob" + i.ToString() + "TextBox";
            if (dynPanel.FindControl(idControl) == null)
            {
                PolozkaSlevyPocetOsob polozka = (PolozkaSlevyPocetOsob)slevy.SlevyPocetOsob[i];
                VytvorDynamickyRadek(i, polozka.PocetOsob.ToString(), polozka.Sleva.ToString("f2"));
            }
        }
    }

    /// <summary>
    /// Uloží nové slevy, případně změny ve slevách.
    /// </summary>
    protected void potvrdButton_Click(object sender, EventArgs e)
    {
        if (Request.QueryString["action"] == "delete")
        {

            if (!SpravceCeniku.SmazatSlevy(int.Parse(idLiteral.Text)))
            {
                errorLiteral.Text = "Chyba při mazání slev.";
                return;
            }
        }
        else
        {
            ArrayList polozkySlev = new ArrayList();
            for (int i = 0; i < int.Parse(pocetRozsahuTextBox.Text); i++)
            {
                string pocetOsobControl = "pocetOsob" + i.ToString() + "TextBox";
                string vyseSlevyControl = "slevaosoby" + i.ToString() + "TextBox";
                PolozkaSlevyPocetOsob polozka = new PolozkaSlevyPocetOsob(int.Parse(((TextBox)dynPanel.FindControl(pocetOsobControl)).Text), float.Parse(((TextBox)dynPanel.FindControl(vyseSlevyControl)).Text));
                polozkySlev.Add(polozka);
            }
            if (!SpravceCeniku.UlozitSlevy(int.Parse(idLiteral.Text), DateTime.Parse(platnostOdTextBox.Text), float.Parse(slevaMaxTextBox.Text), float.Parse(onlineTextBox.Text), float.Parse(partnerskyKodTextBox.Text), float.Parse(vcasnaRezervaceTextBox.Text), polozkySlev))
            {
                errorLiteral.Text = "Chyba při ukládání.";
                return;
            }
        }
        Response.Redirect("Slevy.aspx");
    }


    /// <summary>
    /// Návrat na seznam slev.
    /// </summary>
    protected void zpetButton_Click(object sender, EventArgs e)
    {
        Response.Redirect("Slevy.aspx");
    }

    /// <summary>
    /// Zobrazení/skrytí kalendáře pro výběr data.
    /// </summary>
    protected void platnostOdButton_Click(object sender, EventArgs e)
    {
        if (platnostOdCalendar.Visible == true)
        {
            platnostOdCalendar.Visible = false;
            platnostOdButton.Text = "+";
        }
        else
        {
            platnostOdCalendar.Visible = true;
            platnostOdButton.Text = "-";
        }
    }

    /// <summary>
    /// Změna data začátku platnosti slev.
    /// </summary>
    protected void platnostOdCalendar_SelectionChanged(object sender, EventArgs e)
    {
        platnostOdTextBox.Text = platnostOdCalendar.SelectedDate.ToLongDateString();
        platnostOdCalendar.Visible = false;
        platnostOdButton.Text = "+";
    }

    /// <summary>
    /// Vytvoří dynamický řádek slevy pro počet osob.
    /// </summary>
    /// <param name="i">Číslo řádku.</param>
    /// <param name="pocetOsob">Počet osob.</param>
    /// <param name="sleva">Sleva.</param>
    protected void VytvorDynamickyRadek(int i, string pocetOsob, string sleva)
    {
        dynPanel.Controls.Add(new LiteralControl("<tr><td>" + (i + 1).ToString() + ". počet osob větší než "));

        //Počet osob
        TextBox pocetOsobTextBox = new TextBox();
        pocetOsobTextBox.ID = "pocetOsob" + i.ToString() + "TextBox";
        pocetOsobTextBox.Width = Unit.Pixel(30);
        if (pocetOsob != "")
            pocetOsobTextBox.Text = pocetOsob;
        dynPanel.Controls.Add(pocetOsobTextBox);
        dynPanel.Controls.Add(new LiteralControl(" - sleva: </td><td>"));

        //sleva
        TextBox slevaOsobTextBox = new TextBox();
        slevaOsobTextBox.ID = "slevaosoby" + i.ToString() + "TextBox";
        if (sleva != "")
            slevaOsobTextBox.Text = sleva;
        dynPanel.Controls.Add(slevaOsobTextBox);
        dynPanel.Controls.Add(new LiteralControl("% "));

        //Validator počet osob
        RequiredFieldValidator pocetOsobRequireFild = new RequiredFieldValidator();
        pocetOsobRequireFild.ControlToValidate = "pocetOsob" + i.ToString() + "TextBox";
        pocetOsobRequireFild.Display = ValidatorDisplay.Dynamic;
        pocetOsobRequireFild.ErrorMessage = "<br />Musíte zadat počet osob.";
        pocetOsobRequireFild.ValidationGroup = "slevy";
        dynPanel.Controls.Add(pocetOsobRequireFild);

        //Validator slevy
        RequiredFieldValidator slevytOsobRequireFild = new RequiredFieldValidator();
        slevytOsobRequireFild.ControlToValidate = "slevaosoby" + i.ToString() + "TextBox";
        slevytOsobRequireFild.Display = ValidatorDisplay.Dynamic;
        slevytOsobRequireFild.ErrorMessage = "<br />Musíte zadat výši slevy.";
        slevytOsobRequireFild.ValidationGroup = "slevy";
        dynPanel.Controls.Add(slevytOsobRequireFild);

        dynPanel.Controls.Add(new LiteralControl("</td></tr>"));
    }

}
