﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;

public partial class admin_Uzivatele : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            roleRadioButtonList.DataSource = Roles.GetAllRoles();
            roleRadioButtonList.DataBind();
            if (roleRadioButtonList.SelectedItem == null)
                roleRadioButtonList.Items[3].Selected = true;

            if (Request.QueryString["action"] != null && Request.QueryString["userId"] != null)
            {
                deletePanel.Visible = true;
                usersPanel.Visible = false;
                if (Request.QueryString["action"] == "delete")
                {
                    Uzivatel uzivatel = SpravceUzivatelu.NacistUzivateleSystemu(Request.QueryString["userId"]);
                    if (uzivatel == null)
                        Response.Redirect("Uzivatele.aspx");

                    deleteUserLiteral.Text = uzivatel.Nick + " (" + uzivatel.Jmeno + " " + uzivatel.Prijmeni + ")";

                }
            }
        }
    }

    protected void smazatOkButton_Click(object sender, EventArgs e)
    {
        try
        {
            Uzivatel uzivatel = SpravceUzivatelu.NacistUzivateleSystemu(Request.QueryString["userId"]);
            if (uzivatel == null)
                Response.Redirect("Uzivatele.aspx");

            string[] roleUzivatele = Roles.GetRolesForUser(uzivatel.Nick);

            foreach (string role in roleUzivatele)
            {
                switch (role)
                {
                    case "admin":
                        Administrator admin = SpravceUzivatelu.NacistAdministratora(uzivatel.Id);
                        admin.Smazat();
                        break;
                    case "instruktor":
                        Instruktor instruktor = SpravceUzivatelu.NacistInstruktora(uzivatel.Id);
                        instruktor.Smazat();
                        break;
                    case "partner":
                        Partner partner = SpravceUzivatelu.NactiPartnera(uzivatel.Id);
                        partner.Smazat();
                        break;
                    case "zakaznik":
                        Zakaznik zakaznik = SpravceUzivatelu.NacistZakaznika(uzivatel.Id);
                        zakaznik.Smazat();
                        break;
                }
            }

            SpravceDiskusnihoFora.SmazatVzkazyUzivatele(uzivatel.Id);

            Membership.DeleteUser(uzivatel.Nick, true);
        }
        catch (Exception)
        {

        }
    }


    protected void cancelButton_Click(object sender, EventArgs e)
    {
        Response.Redirect("Uzivatele.aspx");
    }
}
