﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;

public partial class admin_UzivateleDetail : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (Request.QueryString["action"] == null)
            PresmerujNaStrankuUzivatelu();

        if (Request.QueryString["action"] == "view")
        {
            if (Request.QueryString["role"] == null || Request.QueryString["UserId"] == null)
                PresmerujNaStrankuUzivatelu();
            uzivatelViewPanel.Visible = true;

            // Administrátor
            if (Request.QueryString["role"] == "admin")
            {
                h1Literal.Text = "Detail administrátora";
                if (!Page.IsPostBack)
                {
                    Administrator admin = SpravceUzivatelu.NacistAdministratora(Request.QueryString["UserId"]);
                    if (admin == null)
                        PresmerujNaStrankuUzivatelu();
                    adminViewPanel.Visible = true;
                    VypisAdministratorViewPanel(admin);
                }
            }
            // Instruktor
            else if (Request.QueryString["role"] == "instruktor")
            {
                h1Literal.Text = "Detail instruktora";
                if (!Page.IsPostBack)
                {
                    Instruktor instruktor = SpravceUzivatelu.NacistInstruktora(Request.QueryString["UserId"]);
                    if (instruktor == null)
                        PresmerujNaStrankuUzivatelu();
                    instruktorViewPanel.Visible = true;
                    VypisInstruktorViewPanel(instruktor);
                }
            }
            // Partner
            else if (Request.QueryString["role"] == "partner")
            {
                h1Literal.Text = "Detail partnera";
                if (!Page.IsPostBack)
                {
                    Partner partner = SpravceUzivatelu.NactiPartnera(Request.QueryString["UserId"]);
                    if (partner == null)
                        PresmerujNaStrankuUzivatelu();
                    partnerViewPanel.Visible = true;
                    VypisPartnerViewPanel(partner);
                }
            }
            // Zákazník
            else if (Request.QueryString["role"] == "zakaznik")
            {
                h1Literal.Text = "Detail zákazníka";
                if (!Page.IsPostBack)
                {
                    Zakaznik zakaznik = SpravceUzivatelu.NacistZakaznika(Request.QueryString["UserId"]);
                    if (zakaznik == null)
                        PresmerujNaStrankuUzivatelu();
                    zakaznikViewPanel.Visible = true;
                    VypisZakaznikViewPanel(zakaznik);
                }
            }
            else
                PresmerujNaStrankuUzivatelu();

        }
        else if (Request.QueryString["action"] == "view")
        {

        }
        else
            PresmerujNaStrankuUzivatelu();
    }

    /// <summary>
    /// Přesměruje na stránku uživatelů.
    /// </summary>
    protected void PresmerujNaStrankuUzivatelu()
    {
        Response.Redirect("Uzivatele.aspx");
    }

    /// <summary>
    /// Vypíše informace o uživateli na <c>uzivatelViewPanel</c>.
    /// </summary>
    /// <param name="uzivatel">Uživatel.</param>
    protected void VypisUzivatelViewPanel(Uzivatel uzivatel)
    {
        userNameViewLiteral.Text = uzivatel.Nick;
        emailLiteral.Text = uzivatel.Email;
        jmenoLiteral.Text = uzivatel.Jmeno;
        prijmeniLiteral.Text = uzivatel.Prijmeni;
        telefonLiteral.Text = uzivatel.TelefonniCislo;
        foreach (string role in Roles.GetRolesForUser(uzivatel.Nick))
            roleLiteral.Text += role + ", ";
        roleLiteral.Text = roleLiteral.Text.Substring(0, roleLiteral.Text.Length - 2);
    }

    /// <summary>
    /// Vypíše informace o uživateli na <c>uzivatelUpdatePanel</c>.
    /// </summary>
    /// <param name="uzivatel">Uživatel.</param>
    protected void VypisUzivatelUpdatePanel(Uzivatel uzivatel)
    {
        userNameLiteral.Text = uzivatel.Nick;
        Email.Text = uzivatel.Email;
        jmenoTextBox.Text = uzivatel.Jmeno;
        prijmeniTextBox.Text = uzivatel.Prijmeni;
        telefonTextBox.Text = uzivatel.TelefonniCislo;
    }

    /// <summary>
    /// Vypíše informace o zákazníkovi na <c>zakaznikViewPanel</c>.
    /// </summary>
    /// <param name="uzivatel">Zákazník.</param>
    protected void VypisZakaznikViewPanel(Zakaznik zakaznik)
    {
        VypisUzivatelViewPanel(zakaznik);
        uliceLiteral.Text = zakaznik.FakturacniAdresa.Ulice;
        mestoLiteral.Text = zakaznik.FakturacniAdresa.Mesto;
        pscLiteral.Text = zakaznik.FakturacniAdresa.Psc;
    }

    /// <summary>
    /// Vypíše informace o zákazníkovi na <c>zakaznikUpdatePanel</c>.
    /// </summary>
    /// <param name="uzivatel">Zákazník.</param>
    protected void VypisZakaznikUpdatePanel(Zakaznik zakaznik)
    {
        VypisUzivatelUpdatePanel(zakaznik);
        uliceTextBox.Text = zakaznik.FakturacniAdresa.Ulice;
        mestoTextBox.Text = zakaznik.FakturacniAdresa.Mesto;
        pscTextBox.Text = zakaznik.FakturacniAdresa.Psc;
    }

    /// <summary>
    /// Vypíše informace o partnerovi na <c>partnerViewPanel</c>.
    /// </summary>
    /// <param name="uzivatel">Partner.</param>
    protected void VypisPartnerViewPanel(Partner partner)
    {
        VypisUzivatelViewPanel(partner);
        partnerskyKodLiteral.Text = partner.PartnerskyKod;
    }

    /// <summary>
    /// Vypíše informace o partnerovi na <c>zakaznikUpdatePanel</c>.
    /// </summary>
    /// <param name="partner">Partner.</param>
    protected void VypisPartnerUpdatePanel(Partner partner)
    {
        VypisUzivatelUpdatePanel(partner);
        partnerskyKodUpdateLiteral.Text = partner.PartnerskyKod;
    }

    /// <summary>
    /// Vypíše informace o instruktorovi na <c>instruktorViewPanel</c>.
    /// </summary>
    /// <param name="uzivatel">Instruktor.</param>
    protected void VypisInstruktorViewPanel(Instruktor instruktor)
    {
        VypisUzivatelViewPanel(instruktor);
        informaceInstruktorLiteral.Text = instruktor.Informace;
    }

    /// <summary>
    /// Vypíše informace o instruktorovi na <c>instruktorUpdatePanel</c>.
    /// </summary>
    /// <param name="uzivatel">Instruktor.</param>
    protected void VypisInstruktorUpdatePanel(Instruktor instruktor)
    {
        VypisUzivatelUpdatePanel(instruktor);
        informaceTextBox.Text = instruktor.Informace;
    }

    /// <summary>
    /// Vypíše informace o administrátorovi na <c>administratorViewPanel</c>.
    /// </summary>
    /// <param name="Administrator">Administrator.</param>
    protected void VypisAdministratorViewPanel(Administrator admin)
    {
        VypisUzivatelViewPanel(admin);
    }

    /// <summary>
    /// Vypíše informace o instruktorovi na <c>asministratorUpdatePanel</c>.
    /// </summary>
    /// <param name="Administrator">Administrátor.</param>
    protected void VypisAdministratorUpdatePanel(Administrator admin)
    {
        VypisUzivatelUpdatePanel(admin);
    }

    /// <summary>
    /// Načte data z formulare pro uložení.
    /// </summary>
    /// <param name="uzivatel">Uživatel.</param>
    protected void NacistDataZFormulareUzivatele(Uzivatel uzivatel)
    {
        uzivatel.Email = Email.Text;
        uzivatel.Jmeno = jmenoTextBox.Text;
        uzivatel.Prijmeni = prijmeniTextBox.Text;
        uzivatel.TelefonniCislo = telefonTextBox.Text;
    }

    /// <summary>
    /// Zobrazí formuláře pro úpravu uživatele.
    /// </summary>
    protected void upravitUzivateleButton_Click(object sender, EventArgs e)
    {
        Zakaznik zakaznik = SpravceUzivatelu.NacistZakaznika(Request.QueryString["UserId"]);
        if (zakaznik == null)
            PresmerujNaStrankuUzivatelu();

        uzivatelViewPanel.Visible = false;
        zakaznikViewPanel.Visible = false;

        uzivatelUpdatePanel.Visible = true;
        zakaznikUpdatePanel.Visible = true;

        VypisZakaznikUpdatePanel(zakaznik);

    }

    /// <summary>
    /// Zobrazí formuláře pro úpravu partnera.
    /// </summary>    
    protected void upravitParnteraButton_Click(object sender, EventArgs e)
    {
        Partner partner = SpravceUzivatelu.NactiPartnera(Request.QueryString["UserId"]);
        if (partner == null)
            PresmerujNaStrankuUzivatelu();

        uzivatelViewPanel.Visible = false;
        partnerViewPanel.Visible = false;

        uzivatelUpdatePanel.Visible = true;
        partnerUpdatePanel.Visible = true;

        VypisPartnerUpdatePanel(partner);
    }

    /// <summary>
    /// Zobrazí formuláře pro úpravu instruktora.
    /// </summary>  
    protected void upravitInstruktorButton_Click(object sender, EventArgs e)
    {
        Instruktor instruktor = SpravceUzivatelu.NacistInstruktora(Request.QueryString["UserId"]);
        if (instruktor == null)
            PresmerujNaStrankuUzivatelu();

        uzivatelViewPanel.Visible = false;
        instruktorViewPanel.Visible = false;

        uzivatelUpdatePanel.Visible = true;
        instruktorUpdatePanel.Visible = true;

        VypisInstruktorUpdatePanel(instruktor);
    }

    /// <summary>
    /// Zobrazí formuláře pro úpravu administrátora.
    /// </summary>  
    protected void upravitAdministratorButton_Click(object sender, EventArgs e)
    {
        Administrator admin = SpravceUzivatelu.NacistAdministratora(Request.QueryString["UserId"]);
        if (admin == null)
            PresmerujNaStrankuUzivatelu();

        uzivatelViewPanel.Visible = false;
        adminViewPanel.Visible = false;

        uzivatelUpdatePanel.Visible = true;
        adminUpdatePanel.Visible = true;

        VypisAdministratorUpdatePanel(admin);
    }

    /// <summary>
    /// Zrušení úprav zákazníka.
    /// </summary>
    protected void zpetZakaznikButton_Click(object sender, EventArgs e)
    {
        ZakaznikUpdateToViewPanel();
    }

    /// <summary>
    /// Zrušení úprav partnera.
    /// </summary>
    protected void zpetPartnerButton_Click(object sender, EventArgs e)
    {
        PartnerUpdateToViewPanel();
    }

    /// <summary>
    /// Zrušení úprav instruktora.
    /// </summary>
    protected void zpetInstruktorButton_Click(object sender, EventArgs e)
    {
        InstruktorUpdateToViewPanel();
    }

    /// <summary>
    /// Zrušení úprav administrátora.
    /// </summary>
    protected void zpetAdminButton_Click(object sender, EventArgs e)
    {
        AdministratorUpdateToViewPanel();
    }

    /// <summary>
    /// Přepne <c>zakaznikUpdatePanel</c> na <c>zakaznikViewPanel</c>
    /// </summary>
    protected void ZakaznikUpdateToViewPanel()
    {
        uzivatelViewPanel.Visible = true;
        zakaznikViewPanel.Visible = true;

        uzivatelUpdatePanel.Visible = false;
        zakaznikUpdatePanel.Visible = false;
    }

    /// <summary>
    /// Přepne <c>partnerUpdatePanel</c> na <c>partnerViewPanel</c>
    /// </summary>
    protected void PartnerUpdateToViewPanel()
    {

        uzivatelViewPanel.Visible = true;
        partnerViewPanel.Visible = true;

        uzivatelUpdatePanel.Visible = false;
        partnerUpdatePanel.Visible = false;
    }

    /// <summary>
    /// Přepne <c>instruktorUpdatePanel</c> na <c>instruktorViewPanel</c>
    /// </summary>
    protected void InstruktorUpdateToViewPanel()
    {

        uzivatelViewPanel.Visible = true;
        instruktorViewPanel.Visible = true;

        uzivatelUpdatePanel.Visible = false;
        instruktorUpdatePanel.Visible = false;
    }

    /// <summary>
    /// Přepne <c>adminUpdatePanel</c> na <c>adminViewPanel</c>
    /// </summary>
    protected void AdministratorUpdateToViewPanel()
    {

        uzivatelViewPanel.Visible = true;
        adminViewPanel.Visible = true;

        uzivatelUpdatePanel.Visible = false;
        adminUpdatePanel.Visible = false;
    }

    /// <summary>
    /// Uloží data z formuláře zákazníka.
    /// </summary>
    protected void ulozZakaznikButton_Click(object sender, EventArgs e)
    {
        Zakaznik zakaznik = SpravceUzivatelu.NacistZakaznika(Request.QueryString["UserId"]);
        if (zakaznik == null)
            PresmerujNaStrankuUzivatelu();
        NacistDataZFormulareUzivatele(zakaznik);
        zakaznik.FakturacniAdresa.Ulice = uliceTextBox.Text;
        zakaznik.FakturacniAdresa.Mesto = mestoTextBox.Text;
        zakaznik.FakturacniAdresa.Psc = pscTextBox.Text;
        zakaznik.Ulozit();
        ZakaznikUpdateToViewPanel();
        VypisZakaznikViewPanel(zakaznik);
    }

    /// <summary>
    /// Uloží data z formuláře partnera.
    /// </summary>
    protected void ulozizZmenyPartnerButton_Click(object sender, EventArgs e)
    {
        Partner partner = SpravceUzivatelu.NactiPartnera(Request.QueryString["UserId"]);
        if (partner == null)
            PresmerujNaStrankuUzivatelu();

        NacistDataZFormulareUzivatele(partner);
        partner.Ulozit();

        PartnerUpdateToViewPanel();
        VypisPartnerViewPanel(partner);
    }

    /// <summary>
    /// Uloží data z formuláře instruktora.
    /// </summary>
    protected void ulozitZnenyInstruktorButton_Click(object sender, EventArgs e)
    {
        Instruktor instruktor = SpravceUzivatelu.NacistInstruktora(Request.QueryString["UserId"]);
        if (instruktor == null)
            PresmerujNaStrankuUzivatelu();

        NacistDataZFormulareUzivatele(instruktor);
        instruktor.Informace = informaceTextBox.Text;
        instruktor.Ulozit();

        InstruktorUpdateToViewPanel();
        VypisInstruktorViewPanel(instruktor);
    }

    /// <summary>
    /// Uloží data z formuláře administrátora.
    /// </summary>
    protected void ulozitAdminButton_Click(object sender, EventArgs e)
    {
        Administrator admin = SpravceUzivatelu.NacistAdministratora(Request.QueryString["UserId"]);
        if (admin == null)
            PresmerujNaStrankuUzivatelu();

        NacistDataZFormulareUzivatele(admin);
        admin.Ulozit();
        
        AdministratorUpdateToViewPanel();
        VypisAdministratorViewPanel(admin);
    }
    
}
